unit CircleEdUnit;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QMenus, QTypes,OptionUnit, QComCtrls, QExtCtrls, QCheckLst,
  Jab, QButtons,ObjValHelpUnit, QGrids,fmSpellListUnit, QImgList,
  Math;

type
  TConValues = record
      Flag    : LongInt;
      BV      : String[1];
      Text    : String;
  end;

  TConstant = record
      ConName : String;
      ConType : String;
      Values  : Array of TConValues;
  End;

  TObjExtDesc = record
       Keyword : String;
       Desc    : TStringlist;
  end;

  TObjAffFields = record
       Location : integer;
       Value    : integer;
  end;
  
  Txyz = record
    X : Integer;
    Y : Integer;
    Z : Integer;
  end;

  TESpec = Record
   Spec  : String;
   Value : Integer;
  end;

  TDirField = record
   DirNum     : Integer;
   GenDesc    : TStringList;
   Keywords   : String;
   DoorFlag   : ShortInt;
   KeyNum     : Integer;
   RoomLinked : Integer;
  End;

  TWldExtDesc = record
   Keyword : String;
   Desc    : TStringList;
  end;

  TBuyList = record
   BuyType : String;
   BuyList : String;
  end;

  TZonCom = Record
   Command : String[1];
   IfPar   : ShortInt;
   Vnum    : Integer;
   Par3    : Integer;
   Par4    : Integer;
   Comment : String;
  End;

  TObj = record
       Vnum       : Integer;
       Alias      : String;
       ShortDesc  : String;
       LongDesc   : TStringList;
       ActDesc    : String;
       TypeFlag   : Integer;
       ExtraBV    : String;
       WearBV     : String;
       Values     : Array[0..3] of Integer;
       Weight     : Integer;
       Cost       : Integer;
       Rent       : Integer;
       ExtDesc    : Array of TObjExtDesc;
       AffFields  : Array[1..6] of TObjAffFields;
       NrofAF     : Integer;
  end;

  TMob = Record
       Vnum        : Integer;
       Alias       : String;
       ShortDesc   : String;
       LongDesc    : TStringList;
       DetailDesc  : TStringList;
       ActionBV    : String;
       AffectBV    : String;
       Alignment   : Integer;
       TypeFlag    : String[1];
       Level       : integer;
       Thac0       : integer;
       AC          : integer;
       Hitpoint    : TXYZ;
       BHD         : TXYZ;
       Gold        : integer;
       Experience  : integer;
       LoadPos     : integer;
       DefaultPos  : integer;
       Sex         : ShortInt;
       ESpecs      : Array of TESpec;
  End;

  TWld = record
       Vnum        : Integer;
       RoomName    : String;
       RoomDesc    : TStringList;
       ZoneNum     : Integer;
       RoomBV      : String;
       SectorType  : Integer;
       DirectionF  : Array of TDirField;
       ExtraDesc   : Array of TWldExtDesc;
       GridPos     : TPoint;
  End;

  TShp = record
       Vnum           : Integer;
       Items          : Array of Integer;
       ProfitSell     : Double;
       ProfitBuy      : Double;
       BuyList        : Array of TBuyList;
       Messages       : Array[1..7] of String;
       Temper         : ShortInt;
       ShopBV         : String;
       ShopKeeperVNum : Integer;
       WithWhoBV      : String;
       ShopsVNum      : Array of Integer;
       TimeOpen1      : ShortInt;
       TimeClose1     : ShortInt;
       TimeOpen2      : ShortInt;
       TimeClose2     : ShortInt;
       ShopFormat     : String[4];// 3.0 or 2.20
  End;

  TZon = record
       VNum           : Integer;
       ZoneName       : String;
       BottomRoom     : Integer;
       TopRoom        : Integer;
       LifeSpan       : Integer;
       ResetMode      : Integer;
       TopCom         : Array[1..3] of String;//Comments after the Vnum, Zonename and Other 4 parmaters
       Commands       : Array of TZonCom; //M, O, G, E, P, D, and R. and * for comment lines
  End;

  TfmCircleEd = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Tools1: TMenuItem;
    Options1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Load1: TMenuItem;
    OpenDialog1: TOpenDialog;
    pgMain: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    lbObj: TListBox;
    edObjFind: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    edObjVNum: TEdit;
    Label3: TLabel;
    edObjAliasL: TEdit;
    Label4: TLabel;
    edObjShortDesc: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    edObjActionDesc: TEdit;
    chlbExtraBV: TCheckListBox;
    Label7: TLabel;
    chlbWearBV: TCheckListBox;
    Label8: TLabel;
    Label9: TLabel;
    edObjVal0: TEdit;
    edObjVal1: TEdit;
    Label10: TLabel;
    edObjVal2: TEdit;
    Label11: TLabel;
    edObjVal3: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    edObjWeight: TEdit;
    Label14: TLabel;
    edObjCost: TEdit;
    Label15: TLabel;
    edObjRent: TEdit;
    btObjValHelp: TBitBtn;
    chlbTypeFlags: TCheckListBox;
    Label16: TLabel;
    Label17: TLabel;
    Label20: TLabel;
    btObjVNum: TBitBtn;
    btObjNew: TBitBtn;
    btObjDelete: TBitBtn;
    btObjClone: TBitBtn;
    NewObjectFile1: TMenuItem;
    NewMobileFile2: TMenuItem;
    NewWorldFile3: TMenuItem;
    NewZoneFile4: TMenuItem;
    NewShopFile5: TMenuItem;
    N2: TMenuItem;
    SaveDialog1: TSaveDialog;
    SaveObjectFile1: TMenuItem;
    N3: TMenuItem;
    btAccept: TBitBtn;
    meObjLongDesc: TMemo;
    ImageList1: TImageList;
    pmNew: TPopupMenu;
    NewObject1: TMenuItem;
    NewMobileFile1: TMenuItem;
    NewZoneFile1: TMenuItem;
    NewWorldFile1: TMenuItem;
    NewShopFile1: TMenuItem;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    pmSave: TPopupMenu;
    SaveObject1: TMenuItem;
    SaveMobile1: TMenuItem;
    SaveWorld1: TMenuItem;
    SaveZoneFile1: TMenuItem;
    SaveShopFile1: TMenuItem;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    lbMob: TListBox;
    edMobFind: TEdit;
    Label18: TLabel;
    Label19: TLabel;
    edMobVnum: TEdit;
    Label21: TLabel;
    edMobjAliasL: TEdit;
    Label22: TLabel;
    edMobShortDesc: TEdit;
    Label23: TLabel;
    Label24: TLabel;
    btMobVNum: TBitBtn;
    btMobnew: TBitBtn;
    btMobDelete: TBitBtn;
    btMobClone: TBitBtn;
    btMobAccept: TBitBtn;
    meMobLongDesc: TMemo;
    meMobDetailDesc: TMemo;
    chlbMobActionBV: TCheckListBox;
    Label25: TLabel;
    chlbMobAffectionBV: TCheckListBox;
    Label26: TLabel;
    seMobAlign: TSpinEdit;
    Label27: TLabel;
    rbMobS: TRadioButton;
    rbMobE: TRadioButton;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    seMobLvl: TSpinEdit;
    seMovThac0: TSpinEdit;
    seMobArmor: TSpinEdit;
    Label31: TLabel;
    seMobHPX: TSpinEdit;
    Label32: TLabel;
    seMobHPY: TSpinEdit;
    Label33: TLabel;
    seMobHPZ: TSpinEdit;
    Label34: TLabel;
    seMobBHDX: TSpinEdit;
    Label35: TLabel;
    seMobBHDY: TSpinEdit;
    Label36: TLabel;
    seMobBHDZ: TSpinEdit;
    seMobGold: TSpinEdit;
    Label37: TLabel;
    seMobExp: TSpinEdit;
    Label38: TLabel;
    rgMobSex: TRadioGroup;
    chlbMobLoadPos: TCheckListBox;
    Label39: TLabel;
    Label40: TLabel;
    chlbMobDefaultPos: TCheckListBox;
    Label41: TLabel;
    pmOpen: TPopupMenu;
    OpenObjectFile1: TMenuItem;
    OpenMobileFile1: TMenuItem;
    OpenWorldFile1: TMenuItem;
    OpenZoneFile1: TMenuItem;
    OpenShopFile1: TMenuItem;
    SaveMobileFile1: TMenuItem;
    lbWld: TListBox;
    edWldFind: TEdit;
    Label42: TLabel;
    meWldRoomDesc: TMemo;
    Label43: TLabel;
    edWldRoomName: TEdit;
    Label44: TLabel;
    Label45: TLabel;
    edWldVNum: TEdit;
    btWldVNum: TBitBtn;
    btWldNew: TBitBtn;
    btWldDelete: TBitBtn;
    btWldClone: TBitBtn;
    btWldAccept: TBitBtn;
    edWldZone: TEdit;
    Label46: TLabel;
    chlbWldRoomBV: TCheckListBox;
    Label47: TLabel;
    Label48: TLabel;
    chlbWldSectorFlag: TCheckListBox;
    lbWldDirF: TListBox;
    btWldDFadd: TBitBtn;
    Label49: TLabel;
    btWldDFDelete: TBitBtn;
    btWldDFEdit: TBitBtn;
    lbWldED: TListBox;
    btWldEDAdd: TBitBtn;
    Label50: TLabel;
    btWldEDDelete: TBitBtn;
    btWldEDEdit: TBitBtn;
    pmWldGrid: TPopupMenu;
    New1: TMenuItem;
    Delete1: TMenuItem;
    Move1: TMenuItem;
    SaveWorldFile1: TMenuItem;
    lbShp: TListBox;
    edShpFind: TEdit;
    Label51: TLabel;
    Label52: TLabel;
    edShpVNum: TEdit;
    btShpVNum: TBitBtn;
    btShpNew: TBitBtn;
    btShpDelete: TBitBtn;
    btShpClone: TBitBtn;
    btShpAccept: TBitBtn;
    sgShpItems: TStringGrid;
    Label53: TLabel;
    Label54: TLabel;
    Label55: TLabel;
    chlbShpTemperFlags: TCheckListBox;
    Label56: TLabel;
    chlbShpBV: TCheckListBox;
    Label57: TLabel;
    chlbShpWithWhoBV: TCheckListBox;
    Label58: TLabel;
    Label59: TLabel;
    seShpKeeperVnum: TSpinEdit;
    Label60: TLabel;
    seShpOpen1: TSpinEdit;
    Label61: TLabel;
    seShpClose1: TSpinEdit;
    Label62: TLabel;
    seShpOpen2: TSpinEdit;
    Label63: TLabel;
    seShpClose2: TSpinEdit;
    sgShpRooms: TStringGrid;
    Label64: TLabel;
    Label65: TLabel;
    Label66: TLabel;
    edShpMsg1: TEdit;
    Label67: TLabel;
    edShpMsg2: TEdit;
    edShpMsg3: TEdit;
    Label68: TLabel;
    Label69: TLabel;
    edShpMsg4: TEdit;
    Label70: TLabel;
    edShpMsg5: TEdit;
    Label71: TLabel;
    edShpMsg6: TEdit;
    Label72: TLabel;
    edShpMsg7: TEdit;
    lbBuyTypes: TListBox;
    btShpChangeBT: TBitBtn;
    btShpDeleteBT: TBitBtn;
    btShpAddBT: TBitBtn;
    Label73: TLabel;
    edShpProfitSell: TEdit;
    edShpProfitBuy: TEdit;
    Label74: TLabel;
    Label75: TLabel;
    SaveShopFile2: TMenuItem;
    Label76: TLabel;
    Label77: TLabel;
    edZonVNum: TEdit;
    btZonVNum: TBitBtn;
    Label78: TLabel;
    edZonName: TEdit;
    Label79: TLabel;
    Label80: TLabel;
    seZonBotRoom: TSpinEdit;
    seZonTopRoom: TSpinEdit;
    Label81: TLabel;
    seZonLifespan: TSpinEdit;
    Label82: TLabel;
    cbZonReset: TComboBox;
    cbZonCommand: TComboBox;
    seZonIF: TSpinEdit;
    seZonVNum: TSpinEdit;
    seZonPar3: TSpinEdit;
    seZonPar4: TSpinEdit;
    Label83: TLabel;
    labIf: TLabel;
    labVNum: TLabel;
    labPar3: TLabel;
    labPar4: TLabel;
    lbZone: TListBox;
    edZonComment: TEdit;
    Label84: TLabel;
    cbZonPar4: TComboBox;
    cbZonPar3: TComboBox;
    btZonAdd: TBitBtn;
    btZonDelete: TBitBtn;
    btZonChange: TBitBtn;
    btZonInsert: TBitBtn;
    btZonUp: TBitBtn;
    btZonDown: TBitBtn;
    edZonCom1: TEdit;
    Label85: TLabel;
    Label86: TLabel;
    edZonCom2: TEdit;
    Label87: TLabel;
    edZonCom3: TEdit;
    btZonClone: TBitBtn;
    SaveZoneFile2: TMenuItem;
    lbObjExtraDesc: TListBox;
    btObjEDAdd: TBitBtn;
    btObjEDDelete: TBitBtn;
    btObjEDChange: TBitBtn;
    lbObjAffectFields: TListBox;
    btObjAFAdd: TBitBtn;
    btObjAFDelete: TBitBtn;
    btObjAFChange: TBitBtn;
    lbMobESpecs: TListBox;
    btMobESAdd: TBitBtn;
    btMobESDelete: TBitBtn;
    btMobESChange: TBitBtn;
    Label88: TLabel;

    {Common}
    Procedure LoadVectors;
    Procedure ShowVectors;
    Function  ConstIndex( ConstName : String) : Integer;
    Function  StringConv(ConstName: String;num : Integer) : String;
    Function  LoadFlags(ConstName : String) : TStringList;
    Function  LoadBV(ConstName : String) : TStringList;
    Function  GetFlagNumber(TheChecklistBox : TCheckListBox)  : Integer;
    Function  ExtractNumber(Line : String) : Integer;
    Function  ExtractNumberS(Line : String) : String;
    Function  FindNumber(TheCheckbox : TCheckListBox; Num : Integer) : Integer;
    Function  FindString(TheCheckbox : TCheckListBox; S  : String) : Integer;
    Function  ConvertNumS(ConstName : String; Num : Integer)  : String;
    Function  ParseCheckBox(TheCheckbox : TCheckListBox) : String;
    Function  FindIndexRCB(TheCheckbox : TCheckListBox) : Integer;

    {Objects}
    Procedure LoadObjects(Leer : String);
    Function  BuildObjList : Integer;
    Procedure ShowObjList;
    Function  ObjectPos(Vnum : Integer): Integer;
    Procedure ObjToGUI(Num : Integer);
    Function  NewObj(VNum : Integer) : Integer;
    Function  ObjGUItoMem : TObj;
    Function  RenderObj(Obj : TObj) : TStringList;
    Function  ObjEquals(OldObj : TObj) : TObj;
    Procedure ObjSort;
    Procedure ObjShowExt;
    Procedure ObjShowAF;
    {--End Objects--}

    {Mobiles}
    Procedure LoadMobiles(Leer : String);
    Function  BuildMobList : Integer;
    Procedure ShowMobList;
    Procedure MobToGUI(Num : integer);
    Function  MobilePos(Vnum : Integer): Integer;
    Function  MobEquals(OldMob : TMob) : TMob;
    Function  NewMob(VNum : Integer) : Integer ;
    Function  MobGUItoMem : TMob;
    Function  RenderMob(Mob : TMob) : TStringList;
    Procedure MobSort;
    Procedure MobShowES;
    {--End Mobiles--}

    {World}
    Procedure LoadWorlds(Leer : String);
    Procedure WldToGUI(Num : integer);
    Function  WorldPos(Vnum : Integer): Integer;
    Function  BuildWldList : Integer;
    Procedure ShowWldList;
    Procedure WldShowDir;
    Procedure WldShowExt;
    Function  NewWld(VNum : Integer) : Integer ;
    Function  WldEquals(OldWld : TWld) : TWld;
    Function  WldGUItoMem : TWld;
    Procedure WldSort;
    Function  RenderWld(Wld : TWld) : TStringList;

//    Procedure ShowWldGrid;
//    Procedure BuildWldGrid;

    {--End World--}

    {Zones}
    Procedure LoadZones(Leer : String);
    Procedure InsertCommand(Pos : Integer);
    Procedure ChangeCommand(Pos : Integer);
    Procedure ShowCommandList;
    Procedure ShowZoneInfo;
    Procedure BuildZoneList;
    Function  ZonPrevCom(Com : String ;Pos : Integer) : integer;
    Procedure ZonComGUI( ComPos : Integer);

    {--End Zones--}

    {Shops}
    Procedure LoadShops(Leer : String);
    Procedure ShpToGUI(Num : integer);
    Function  BuildShpList : Integer;
    Procedure ShowShpList;
    Function  ShopPos(Vnum : Integer): Integer;
    Function  NewShp(VNum : Integer) : Integer ;
    Function  ShpEquals(OldShp : TShp) : TShp;
    Procedure ShpSort;
    Function  RenderShp(Shp : TShp) : TStringList;
    Function  ShpGUItoMem : TShp;
    {--End Shops--}

    {GUI}
//    Procedure pmObjAffectFieldItemsClick(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure edObjVNumKeyPress(Sender: TObject; var Key: Char);
    procedure edObjVal0KeyPress(Sender: TObject; var Key: Char);
    procedure btObjValHelpClick(Sender: TObject);
    procedure rgObjTypeFlagClick(Sender: TObject);
    procedure chlbTypeFlagsClickCheck(Sender: TObject);
    procedure ssgObjAffectFieldsKeyPress(Sender: TObject; var Key: Char);
    procedure lbObjClick(Sender: TObject);
    procedure btObjValHelpContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure btObjVNumClick(Sender: TObject);
    procedure edObjFindChange(Sender: TObject);
    procedure btObjNewClick(Sender: TObject);
    procedure SaveObjectFile1Click(Sender: TObject);
    procedure btAcceptClick(Sender: TObject);
    procedure NewObjectFile1Click(Sender: TObject);
    procedure btObjDeleteClick(Sender: TObject);
    procedure btObjCloneClick(Sender: TObject);
    procedure seMobAlignChanged(Sender: TObject; NewValue: Integer);
    procedure ssgMobESpecsKeyPress(Sender: TObject; var Key: Char);
    procedure chlbMobLoadPosClickCheck(Sender: TObject);
    procedure rbMobSClick(Sender: TObject);
    procedure lbMobClick(Sender: TObject);
    procedure edMobFindChange(Sender: TObject);
    procedure btMobnewClick(Sender: TObject);
    procedure OpenObjectFile1Click(Sender: TObject);
    procedure OpenMobileFile1Click(Sender: TObject);
    procedure OpenWorldFile1Click(Sender: TObject);
    procedure OpenZoneFile1Click(Sender: TObject);
    procedure OpenShopFile1Click(Sender: TObject);
    procedure btMobDeleteClick(Sender: TObject);
    procedure btMobCloneClick(Sender: TObject);
    procedure btMobVNumClick(Sender: TObject);
    procedure btMobAcceptClick(Sender: TObject);
    procedure NewMobileFile2Click(Sender: TObject);
    procedure SaveMobileFile1Click(Sender: TObject);
//    procedure sgWorldDrawCell(Sender: TObject; ACol, ARow: Integer;
//      Rect: TRect; State: TGridDrawState);
    procedure btWldDFaddClick(Sender: TObject);
    procedure btWldEDAddClick(Sender: TObject);
    procedure edWldFindChange(Sender: TObject);
    procedure btWldVNumClick(Sender: TObject);
    procedure lbWldClick(Sender: TObject);
    procedure chlbWldSectorFlagClickCheck(Sender: TObject);
    procedure NewWorldFile3Click(Sender: TObject);
    procedure btWldDFEditClick(Sender: TObject);
    procedure btWldDFDeleteClick(Sender: TObject);
    procedure btWldEDDeleteClick(Sender: TObject);
    procedure btWldEDEditClick(Sender: TObject);
    procedure btWldNewClick(Sender: TObject);
    procedure btWldDeleteClick(Sender: TObject);
    procedure btWldCloneClick(Sender: TObject);
    procedure btWldAcceptClick(Sender: TObject);
    procedure SaveWorldFile1Click(Sender: TObject);
    procedure sgShpItemsKeyPress(Sender: TObject; var Key: Char);
    procedure sgShpRoomsKeyPress(Sender: TObject; var Key: Char);
    procedure edShpFindChange(Sender: TObject);
    procedure NewShopFile5Click(Sender: TObject);
    procedure edShpProfitSellKeyPress(Sender: TObject; var Key: Char);
    procedure chlbShpTemperFlagsClickCheck(Sender: TObject);
    procedure lbShpClick(Sender: TObject);
    procedure btShpVNumClick(Sender: TObject);
    procedure btShpNewClick(Sender: TObject);
    procedure btShpDeleteClick(Sender: TObject);
    procedure btShpCloneClick(Sender: TObject);
    procedure btShpAcceptClick(Sender: TObject);
    procedure SaveShopFile2Click(Sender: TObject);
    procedure btShpAddBTClick(Sender: TObject);
    procedure btShpDeleteBTClick(Sender: TObject);
    procedure btShpChangeBTClick(Sender: TObject);
    procedure cbZonCommandChange(Sender: TObject);
    procedure btZonVNumClick(Sender: TObject);
    procedure NewZoneFile4Click(Sender: TObject);
    procedure btZonAddClick(Sender: TObject);
    procedure btZonInsertClick(Sender: TObject);
    procedure btZonUpClick(Sender: TObject);
    procedure btZonDownClick(Sender: TObject);
    procedure btZonChangeClick(Sender: TObject);
    procedure btZonDeleteClick(Sender: TObject);
    procedure lbZoneClick(Sender: TObject);
    procedure btZonCloneClick(Sender: TObject);
    procedure SaveZoneFile2Click(Sender: TObject);
    procedure btObjEDAddClick(Sender: TObject);
    procedure btObjEDDeleteClick(Sender: TObject);
    procedure btObjEDChangeClick(Sender: TObject);
    procedure btObjAFAddClick(Sender: TObject);
    procedure btObjAFChangeClick(Sender: TObject);
    procedure btObjAFDeleteClick(Sender: TObject);
    procedure btMobESAddClick(Sender: TObject);
    procedure btMobESDeleteClick(Sender: TObject);
    procedure btMobESChangeClick(Sender: TObject);
    procedure About1Click(Sender: TObject);

  private
    { Private declarations }
  public
    Constants : Array of TConstant;
  end;

var
  fmCircleEd: TfmCircleEd;
  ZoneFile,
  WldFile,
  ShpFile,
  ObjFile,
  MobFile,
  Options   : TStringList;



  Objects : Array of TObj;
  CurObj  : Integer = -1;
  ObjZone : integer = -1;
  ObjExt  : Array of TObjExtDesc;
  ObjAF   : Array[1..6] of TObjAffFields;
  ObjNrAF : Integer;

  Mobiles : Array of TMob;
  CurMob  : Integer = -1;
  MobZone : Integer = -1;
  MobES   : Array of TESpec;

  Worlds  : Array of TWld;
  WldDir  : Array of TDirField;
  WldExt  : Array of TWldExtDesc;
  CurWld  : Integer = -1;
  WldZone : Integer = -1;
 // VNumCheck  : Array of integer; //To prevent endless loop  in grid building

  Shops   : Array of TShp;
  ShpBuy  : Array of TBuyList;
  CurShp  : Integer = -1;
  ShpZone : Integer = -1;

  Zone    : TZon;
  CurZon  : Integer = -1;
  ZonZone : Integer = -1;
//  ZontvRoot : TTreeNode;

implementation

uses
    fmWldDirFieldUnit,fmWldExtraDescUnit,fmShpBuyTypesUnit,
    fmObjExtraDescUnit, fmObjAFUnit, fmMobESpecUnit;
{$R *.xfm}

{Common}


{Function returns all text after an * if not before a ~}
Function ExtractComment(Var Line : String) : String;
var
   i,
   ptilde,
   pstar : Integer;
Begin
     Result := '';
     ptilde := pos('~',Line);
     pstar := pos('*',Line);
     if pstar = 0 then exit;
     if pstar < ptilde then
     Begin
          i := 2;
          Repeat
                pstar := posnum('*',Line,i);
          until (pstar > ptilde) or (pstar = 0);
          if pstar = 0 then exit; 
     End;

     Result := Copy(Line,pstar+1,Length(Line)-pstar);
     Line   := Copy(line,1,pstar-1);
End;

{Function returns remaining text after PARS space seperated words}
Function ExtractComComment(Line : String;pars : Integer) : String;
var
   PL,
   i   : integer;
   pkar,
   kar : char;
Begin
     if (pars = 0) or (Line = '') then exit;
     Line := Trim(Line);
     PL := 0;
     i  := 1;
     pkar := '-';
     Repeat
           kar := Line[i];
           if (kar = ' ') and (pkar <> ' ') then inc(PL);
           pkar := kar;
           inc(i);
     Until (PL = pars) or (i = Length(Line));
     Result := Copy(Line,i,Length(Line)-i+1);
     if (i = Length(Line)) then Result := ''
End;

{Set one TObjExtDesc equals to another TObjExtDesc}
Function ObjExtraDescEquals(OldExtraDesc : TObjExtDesc) : TObjExtDesc;
Begin
     With Result do
     Begin
          Desc := TStringList.Create;
          Desc.AddStrings(OldExtraDesc.Desc);
          Keyword := OldExtraDesc.Keyword;
     End;
End;

{Set one TObjAffFields equals to another TObjAffFields}
Function ObjAFEquals(OldAF : TObjAffFields) : TObjAffFields;
Begin
     With Result do
     Begin
          Location := OldAF.Location;
          Value    := OldAF.Value;
     End;
End;

{Set one TESpec equals to another TESpec}
Function MobESEquals(OldES : TESpec) : TESpec;
Begin
     With Result do
     Begin
          Spec := OldES.Spec;
          Value := OldES.Value
     End;
End;

{Set one TDirField equals to another TDirField}
Function DirFieldEquals(OldDirField : TDirField) : TDirField;
Begin
     With Result do
     Begin
          GenDesc := TStringList.Create;
          DirNum     := OldDirField.DirNum;
          GenDesc.AddStrings(OldDirField.GenDesc);
          Keywords   := OldDirField.Keywords;
          DoorFlag   := OldDirField.DoorFlag;
          KeyNum     := OldDirField.KeyNum;
          RoomLinked := OldDirField.RoomLinked;
     End;
End;

{Set one TWldExtDesc equals to another TWldExtDesc}
Function WldExtraDescEquals(OldExtraDesc : TWldExtDesc) : TWldExtDesc;
Begin
     With Result do
     Begin
          Desc := TStringList.Create;
          Desc.AddStrings(OldExtraDesc.Desc);
          Keyword := OldExtraDesc.Keyword;
     End;
End;


{Set a TZonCom equals to paramters}
Function ZonComEquals(Com : String;Ifflag,VNum,par3,par4 : integer; Comment : String) : TZonCom;
Begin
     Result.Command := Com;
     Result.IfPar   := IfFlag;
     Result.Vnum    := VNum;
     Result.Par3    := Par3;
     Result.Par4    := Par4;
     Result.Comment := Comment;
End;

{returns text of flag}
Function TfmCircleEd.StringConv(ConstName: String;num : Integer) : String;
var
   ind,
   i   : integer;

Begin
     ind := ConstIndex(ConstName);
     Result := '';
     for i := 0 to length(Constants[ind].Values)-1 do
     Begin
          if Constants[ind].Values[i].Flag = num then
          Begin
               Result := UpperCase(Constants[ind].Values[i].Text);
               exit;
          End;
     End;
End;

{Returns the index of constant with name ConstName}
Function TfmCircleEd.ConstIndex( ConstName : String) : Integer;
var
   i : integer;
Begin
     Result := -1;
     for i := 0 to Length(Constants)-1 do
         if Constants[i].ConName = ConstName then
         Begin
              Result := i;
              exit;
         End;
End;

{Function returns second parameter}
Function GetConvKar(Line : String) : String;
Var
   s1,s2 : String;
Begin
     GetParams(Line,[@S1,@S2]);
     Result := S2;
End;

{returns the index of previous occurenc of commond com back from pos}
Function TfmCircleEd.ZonPrevCom(Com : String ;Pos : Integer) : integer;
Var
   i : integer;
Begin
     Result := -1;
     if (Pos > Length(Zone.Commands) ) or
        (Pos < 0 )                     then exit;
     for i := pos-1 downto 0 do
     Begin
          if Zone.Commands[i].Command = 'M' then
          Begin
               Result := i;
               Exit;
          End;
     End;
End;

{Function returns string from checkbox's checked items first character}
Function TfmCircleEd.ParseCheckBox(TheCheckbox : TCheckListBox) : String;
Var
   i  : Integer;
   s1 : String;
Begin
     Result := '';
     for i := 0 to TheCheckbox.Rows-1 do
     Begin
          if TheCheckBox.Checked[i] then
          Begin
               GetParams(TheCheckBox.Items[i],[@S1]);
               Result := Result + S1;
          End;
     End;
End;

{Functions returns an ascii string from a numeric flag based on values of constant Constname}
Function TfmCircleEd.ConvertNumS(ConstName : String; Num : Integer) : String;
Var
   ind,
   DivN,i,
   ResN  : Integer;
Begin
     Result := '';
     ind := ConstIndex(ConstName);
     for i := Length(Constants[ind].Values)-1 downto 0 do
     Begin
          DivN := Constants[ind].Values[i].Flag;
          ResN := Num div DivN;
          if ResN = 1 then Result := Result + Constants[ind].Values[i].BV;
          if (ResN <> 1) and (ResN <> 0) then exit; //Bit flags in conv file is corrupt
          Num := Num - (DivN*ResN);
     End;
End;

{returns the selected checks first character}
Function TfmCircleEd.GetFlagNumber(TheChecklistBox : TCheckListBox)  : Integer;
Var
   LN : String;
   i  : integer;
Begin
     i := -1;
     Repeat inc(i);
     until (TheChecklistBox.Checked[i] = true);
     LN := TheChecklistBox.Items[i];
     Result := StrToInt(Copy(LN,1,Pos(' ',LN)-1));
End;



{Returns a number of first word in line}
Function TfmCircleEd.ExtractNumber(Line : String) : Integer;
Begin
     Result := StrToInt(Copy(Line,1,pos(' ',Line)-1));
End;
{Returns a string of first word in line}
Function TfmCircleEd.ExtractNumberS(Line : String) : String;
Begin
     Result := Copy(Line,1,pos(' ',Line)-1);
End;

{Returns the number of the checked box first word}
Function TfmCircleEd.FindNumber(TheCheckbox : TCheckListBox; Num : Integer) : Integer;
Var
   i  : Integer;
Begin
     for i := 0 to TheCheckbox.Items.Count-1 do
     Begin
          if ExtractNumber(TheCheckbox.Items[i]) = Num then
          Begin
               Result := i;
               Exit;
          End;
     End;
     Result := -1;
End;

{Returns the String of the checked box first word}
Function TfmCircleEd.FindString(TheCheckbox : TCheckListBox; S : String) : Integer;
Var
   i  : Integer;
Begin
     for i := 0 to TheCheckbox.Items.Count-1 do
     Begin
          if ExtractNumberS(TheCheckbox.Items[i]) = S then
          Begin
               Result := i;
               Exit;
          End;
     End;
     Result := -1;
End;

Function TfmCircleEd.FindIndexRCB(TheCheckbox : TCheckListBox) : Integer;
Var
   i  : Integer;
Begin
     for i := 0 to TheCheckbox.Items.Count-1 do
     Begin
          if TheCheckbox.Checked[i] then
          Begin
               Result := i;
               Exit;
          End;
     End;
     Result := -1;
End;

{Function FindText(leer : String ; num : Integer) : String ;
Var
   ConfLeer : TStringList;
   Get,Code,i  : Integer;
   p1,p2       : String;
Begin
     Result := '';
     ConfLeer := TStringList.Create;
     ConfLeer.LoadFromFile(leer);
     for i := 0 to ConfLeer.Count-1 do
     Begin
          if GetParams(ConfLeer.Strings[i],[@p1,@p2]) >= 2 then
          Begin
               Val(p1,Get,code);
               if (code = 0) then
                  if Get = Num then
                  Begin
                       Result := p2;
                       Exit;
                  End;
          End;
     End;
End; }

{Return true if line starts with "[" and ends with "]"}
Function IsHeader(Line : String) : Boolean;
Begin
     if (Line[1] = '[') and (Line[Length(Line)] = ']') then Result := True Else Result := false;
End;

{Returns text between first and last character }
Function GetHeader(Line : String) : String;
Begin
     Trim(Line);
     if Length(Line) < 3 then
     Begin
          Result := '';
          Exit;
     End;
     Result := Copy(Line,2,Length(Line)-2);
End;

{return stringlist with flag values off constant  }
Function TfmCircleEd.LoadFlags(ConstName : String) : TStringList;
Var
   i,
   CInd : Integer;
Begin
     Result := TStringList.Create;
     if Length(Constants) < 1 then exit;
     Cind := ConstIndex(ConstName);
     if CInd = -1 then exit;

     For i := 0 to Length(Constants[CInd].Values)-1 do
     Begin
          Result.Add(IntToStr(Constants[CInd].Values[i].Flag)+' '+Constants[CInd].Values[i].Text);
     End;
End;

Function TfmCircleEd.LoadBV(ConstName : String) : TStringList;
Var
   i,
   CInd : Integer;
Begin
     Result := TStringList.Create;
     if Length(Constants) < 1 then exit;
     Cind := ConstIndex(ConstName);
     if CInd = -1 then exit;
     For i := 0 to Length(Constants[CInd].Values)-1 do
     Begin
          Result.Add(Constants[CInd].Values[i].BV+' '+Constants[CInd].Values[i].Text);
     End;
End;

{--------------------------------------------------------------------------------}
{----------------------LOAD VECTORS----------------------------------------------}
{--------------------------------------------------------------------------------}
{Functions that loads from file all the bitvector value, Flag Values }
Procedure TfmCircleEd.LoadVectors;
Var
   ConstantFile : TStringList;
   i,num,num2,
   num1,code1,
   Lmode        : integer;
   Line,p1,p2   : String;         
Begin
     ConstantFile := TStringList.Create;
     ConstantFile.LoadFromFile('constant.dat');
     LMode := 0;
     i     := 0;
     Repeat
           Line := ConstantFile.Strings[i];
           Case LMode of
             0 : if (Line <> '') and (Line[1] <> '*') then    //Looking for header
                 Begin
                      If GetParams(Line,[@p1,@p2]) >= 2 then
                      Begin
                           if IsHeader(p1) and IsHeader(p2) then
                           Begin
                                num := Length(Constants);
                                SetLength(Constants,num+1);
                                Constants[num].ConName := GetHeader(p1);
                                Constants[num].ConType := GetHeader(p2);
                                if p2 = '[Flag]' then Lmode := 1 Else
                                if p2 = '[BV]'   then Lmode := 2 Else
                                if p2 = '[Spec]' then Lmode := 3;
                           End;
                      End;
                 End;
             1 : If StartWith('$',line) then Lmode := 0 Else       //Flag Type constants
                 If Line <> '' then
                 Begin
                      if not StartWith('*',line)then
                      if GetParams(Line,[@p1]) >= 1 then
                      Begin
                           Val(p1,num1,code1);
                           if Code1 = 0 then
                           Begin
                                num  := Length(Constants);
                                num2 := Length(Constants[num-1].Values);
                                SetLength(Constants[num-1].Values,num2+1);
                                Constants[num-1].Values[num2].Flag := num1;
                                Constants[num-1].Values[num2].Text := ExtractComComment(Line,1);
                           End;
                      End;
                 End;
             2 : If StartWith('$',line) then Lmode := 0 Else    //Bitvectors
                 If Line <> '' then
                 Begin
                      if not StartWith('*',line)then
                      if GetParams(Line,[@p1,@p2]) >= 2 then
                      Begin
                           Val(p2,num1,code1);
                           if Code1 = 0 then
                           Begin
                                num  := Length(Constants);
                                num2 := Length(Constants[num-1].Values);
                                SetLength(Constants[num-1].Values,num2+1);
                                Constants[num-1].Values[num2].Flag := num1;
                                Constants[num-1].Values[num2].BV   := p1;
                                Constants[num-1].Values[num2].Text := ExtractComComment(Line,2);
                           End;
                      End;
                 End;
             3 : If StartWith('$',line) then Lmode := 0 Else    //Other
                 If Line <> '' then
                 Begin
                      if GetParams(Line,[@p1]) >= 1 then
                      Begin
                           num  := Length(Constants);
                           num2 := Length(Constants[num-1].Values);
                           SetLength(Constants[num-1].Values,num2+1);
                           Constants[num-1].Values[num2].Text := p1;
                      End;
                 End;
           End;
           inc(i);
     Until (i = ConstantFile.Count);
End;

{Put constant values into checklist boxes }
Procedure TfmCircleEd.ShowVectors;
Begin
     chlbtypeFlags.Items.Clear;
     chlbtypeFlags.Items.AddStrings( LoadFlags('Object_TypeFlag'));

     chlbExtraBV.Items.Clear;
     chlbExtraBV.Items.AddStrings(LoadBV('Object_ExtraBV' ));

     chlbWearBV.Items.Clear;
     chlbWearBV.Items.AddStrings(LoadBV('Object_WearBV'));

     chlbMobActionBV.Items.Clear;
     chlbMobActionBV.Items.AddStrings(LoadBV('Mobile_ActionBV'));

     chlbMobAffectionBV.Items.Clear;
     chlbMobAffectionBV.Items.AddStrings(LoadBV('Mobile_AffectionBV'));

     chlbMobLoadPos.Items.Clear;
     chlbMobLoadPos.Items.AddStrings(LoadFlags('Mobile_PositionFlag'));
     chlbMobDefaultPos.Items.Clear;
     chlbMobDefaultPos.Items.AddStrings(LoadFlags('Mobile_PositionFlag'));

     chlbWldRoomBV.Items.Clear;
     chlbWldRoomBV.Items.AddStrings(LoadBV('World_RoomBV'));

     chlbWldSectorFlag.Items.Clear;
     chlbWldSectorFlag.Items.AddStrings(LoadFlags('World_SectorFlag'));

     cbZonPar3.Items.Clear;
     cbZonPar3.Items.AddStrings(LoadFlags('World_ExitDirection'));
     if cbZonPar3.Items.Count > 0 then
        cbZonPar3.ItemIndex := 0;

     cbZonPar4.Items.Clear;
     cbZonPar4.Items.AddStrings(LoadFlags('Zone_DoorFlag'));
     if cbZonPar4.Items.Count > 0 then
        cbZonPar4.ItemIndex := 0;

     chlbShpTemperFlags.Items.Clear;
     chlbShpTemperFlags.Items.AddStrings(LoadFlags('Shop_TemperFlag'));
     if chlbShpTemperFlags.Items.Count > 0 then
        chlbShpTemperFlags.Checked[0] := true;

     chlbShpBV.Items.Clear;
     chlbShpBV.Items.AddStrings(LoadBV('Shop_BV'));

     chlbShpWithWhoBV.Items.Clear;
     chlbShpWithWhoBV.Items.AddStrings(LoadBV('Shop_WithwWhoBV'));

End;



{-----------------}
{OBJECT PROCEDURES}
{-----------------}

{Assign one Object equal to a another}
Function TfmCircleEd.ObjEquals(OldObj : TObj) : TObj;
Var
   i,j : Integer;
Begin
     Result.Vnum := OldObj.Vnum;
     Result.Alias := OldObj.Alias;
     Result.ShortDesc := OldObj.ShortDesc;
     Result.ActDesc := OldObj.ActDesc;
     Result.TypeFlag := OldObj.TypeFlag;
     Result.ExtraBV := OldObj.ExtraBV;
     Result.WearBV := OldObj.WearBV;

     Result.Weight := OldObj.Weight;
     Result.Cost := OldObj.Cost;
     Result.Rent := OldObj.Rent;
     Result.NrofAF := OldObj.NrofAF;
     for i := 1 to 3 do
         Result.Values[i] := OldObj.Values[i];

     for i := 1 to 6 do
     Begin
          Result.AffFields[i].Location := OldObj.AffFields[i].Location;
          Result.AffFields[i].Value := OldObj.AffFields[i].Value;
     End;

     Result.LongDesc := TStringlist.Create;
     Result.LongDesc.Clear;
     Result.LongDesc.AddStrings(OldObj.LongDesc);

     SetLength(Result.ExtDesc,0);
     SetLength(Result.ExtDesc,Length(OldObj.ExtDesc));
     for j := 0 to Length(OldObj.ExtDesc)-1 do
     Begin
          Result.ExtDesc[j].Keyword := OldObj.ExtDesc[j].Keyword;
          Result.ExtDesc[j].Desc := OldObj.ExtDesc[j].Desc;
     End;
End;

{Function which parse the Object File into memory}
Function TfmCircleEd.BuildObjList : Integer;
Var
   Num,
   Num1,
   Num2,
   Num3,
   Code,
   Code1,
   Code2,
   Code3,
   NrofObj,
   i       : Integer;
   Lmode   : Integer;
   p,p1,p2,p3,
   Line    : String;
Begin
//     Result  := 0;
     i       := 0;
     NrofObj := 0;
     LMode   := 0; //Not in Object

     SetLength(Objects,0);

     //lbObj.Items.Clear;
     Repeat
           Line := ObjFile.Strings[i];
           Case LMode of
           -1 : begin end; //End of File It should not reach this
            0 : if (StartWith('#',Line)) and (Line <> '') then        // Not in Object
                Begin
                     GetParams(Line,[@p1]);
                     delete(p1,1,1);
                     Val(p1,Num,Code);
                     if Code = 0 then
                     Begin
                          //Check for duplicate VNum's
                          inc(NrofObj);
                          SetLength(Objects,NrofObj);
                          Objects[NrofObj-1].Vnum := Num;
                          Objects[NrofObj-1].LongDesc := TStringList.Create; //Create LongDesc
                          Lmode := 1; // In object Next Alias;
                     End;
                End;
            1 : Begin  //Alias List
                     Num := Pos('~',Line);
                     if Num = 0 then Objects[NrofObj-1].Alias := Objects[NrofObj-1].Alias + Line
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                          //p1 := Trimright(p1);
                          Objects[NrofObj-1].Alias := Objects[NrofObj-1].Alias + p1;
                          Lmode := 2; //Next Short Description
                     End;
                End;
            2 : Begin  //Short Description
                     Num := Pos('~',Line);
                     if Num = 0 then Objects[NrofObj-1].ShortDesc := Objects[NrofObj-1].ShortDesc + Line
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                         // p1 := Trimright(p1);
                          Objects[NrofObj-1].ShortDesc := Objects[NrofObj-1].ShortDesc + p1;
                          Lmode := 3; //Next Long Description
                     End;
                End;
            3 : Begin  //Long Description   edObjLongDesc
                     Num := Pos('~',Line);
                     if Num = 0 then Objects[NrofObj-1].LongDesc.Add(Line)
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                        //  p1 := Trimright(p1);
                          Objects[NrofObj-1].LongDesc.Add(p1);
                          Lmode := 4; //Next Action Description
                     End;
                End;
            4 : Begin  //Action Descriptions
                     Num := Pos('~',Line);
                     if Num = 0 then Objects[NrofObj-1].ActDesc := Objects[NrofObj-1].ActDesc + Line
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                         // p1 := Trimright(p1);
                          Objects[NrofObj-1].ActDesc := Objects[NrofObj-1].ActDesc + p1;
                          Lmode := 5; //Next Flag & Bitvectors
                     End;
                End;
            5 : if (Line <> '') then   //Type Flag, Extra b.v. and Wear b.v.
                Begin
                     if GetParams(Line,[@p1,@p2,@p3]) >= 1 then   //with ascii Extra b.v. and Wear b.v could be empty
                     Begin
                          Val(p1,Num1,Code1);
                          Val(p2,Num2,Code2);
                          Val(p3,Num3,Code3);
                          If Code1 = 0 then //The type flag must be a number
                          Begin
                               Objects[NrofObj-1].TypeFlag := Num1;
                               if Code2 = 0 then
                               Begin
                                    p2 := ConvertNumS('Object_ExtraBV',num2); //Just assuming this works
                               End;
                               Objects[NrofObj-1].ExtraBV := p2;
                               if Code3 = 0 then
                               Begin
                                    p3 := ConvertNumS('Object_WearBV',num3); //Just assuming this works
                               End;
                               Objects[NrofObj-1].WearBV := p3;
                               LMode := 6; //Next Value 0-3
                          End;
                     End;

                End;
            6 : if (Line <> '') then //Value 0-3
                Begin
                     if GetParams(Line,[@p,@p1,@p2,@p3]) >= 4 then
                     Begin
                          Val(p ,Num ,Code);
                          Val(p1,Num1,Code1);
                          Val(p2,Num2,Code2);
                          Val(p3,Num3,Code3);
                          If (Code  = 0) and
                             (Code1 = 0) and
                             (Code2 = 0) and
                             (Code3 = 0) then //The Values must be numbers
                          Begin
                               Objects[NrofObj-1].Values[0] := Num;
                               Objects[NrofObj-1].Values[1] := Num1;
                               Objects[NrofObj-1].Values[2] := Num2;
                               Objects[NrofObj-1].Values[3] := Num3;
                               LMode := 7; //Next weight cost and rent
                          End;
                     End;

                End;
            7 : if (Line <> '') then // Weight, cost and rent
                Begin
                     if GetParams(Line,[@p1,@p2,@p3]) >= 3 then
                     Begin
                          Val(p1,Num1,Code1);
                          Val(p2,Num2,Code2);
                          Val(p3,Num3,Code3);
                          If (Code1 = 0) and
                             (Code2 = 0) and
                             (Code3 = 0) then //The weight cost and rent must be a numbers
                          Begin
                               Objects[NrofObj-1].Weight := Num1;
                               Objects[NrofObj-1].Cost   := Num2;
                               Objects[NrofObj-1].Rent   := Num3;
                               LMode := 8; //Next checking for Effects , affections nect obj or end
                          End;
                     End;

                End;
            8 : if (Line <> '') then //Cchecking for Effects , Affections next obj or end of file($)
                Begin
                     if GetParams(Line,[@p1]) >= 1 then
                     Begin
                          if p1 = 'E' then
                          Begin
                               num := Length(Objects[NrofObj-1].ExtDesc);
                               SetLength(Objects[NrofObj-1].ExtDesc,num+1);
                               Objects[NrofObj-1].ExtDesc[num].Desc := TStringList.Create;
                               Lmode := 9; //Effects  keyword
                          End;
                          if p1 = 'A' then
                          Begin
                               Lmode := 11; //Affections
                               inc(Objects[NrofObj-1].NrofAF);
                               if Objects[NrofObj-1].NrofAF > 6 then LMode := 0; //Only 6 Affect fields look for new VNum
                          End;
                          if p1 = '$' then Lmode := -1; //Finished
                          if Startwith('#',p1) then     // new object
                          Begin
                               dec(i);                  //go back one line
                               Lmode := 0;              //and start on nect object
                          End;
                     End;
                End;
            9 : Begin
                     Num  := Pos('~',Line);
                     Num1 := Length(Objects[NrofObj-1].ExtDesc);
                     if Num = 0 then Objects[NrofObj-1].ExtDesc[num1-1].Keyword := Objects[NrofObj-1].ExtDesc[num1-1].Keyword + Line
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                          p1 := Trimright(p1);
                          Objects[NrofObj-1].ExtDesc[num1-1].Keyword := Objects[NrofObj-1].ExtDesc[num1-1].Keyword + p1;
                          Lmode := 10; //Next Effect Description
                     End;
                End;
           10 : Begin
                     Num  := Pos('~',Line);
                     Num1 := Length(Objects[NrofObj-1].ExtDesc);
                     if Num = 0 then Objects[NrofObj-1].ExtDesc[num1-1].Desc.Add(Line)
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                          p1 := Trimright(p1);
                          Objects[NrofObj-1].ExtDesc[num1-1].Desc.Add(p1);
                          Lmode := 8; //Next checking for Effects , affections next obj or end
                     End;
                End;
           11 : if (Line <> '') then
                Begin
                     if GetParams(Line,[@p1,@p2]) >= 2 then
                     Begin
                          num := Objects[NrofObj-1].NrofAF;
                          Val(p1,Num1,Code1);
                          Val(p2,Num2,Code2);
                          If (Code1 = 0) and
                             (Code2 = 0) then //The location and value must be numbers
                          Begin
                               Objects[NrofObj-1].AffFields[num].Location := Num1;
                               Objects[NrofObj-1].AffFields[num].Value    := Num2;
                               LMode := 8; //Next checking for Effects , affections nect obj or end
                          End;
                     End;

                End;

            Else ShowMessage('no mode??');
           End;


           inc(i);
     Until (i = ObjFile.Count) or (Lmode = -1); //i should be pass ObjFile.Count-1
     Result := i-1;
     //Check for duplicates

End;

{Returns the info from the GUI}
Function TfmCircleEd.ObjGUItoMem : TObj;
Var
   i,
   Num,Code : Integer;
Begin
     if (ObjZone = -1) or (CurObj = -1) then exit;
     With Result do
     Begin
          VNum       := StrToInt(edObjVNum.Text);
          Alias      := edObjAliasL.Text;
          ShortDesc  := edObjShortDesc.Text;
          //LongDesc   := edObjLongDesc.Text;
          Result.LongDesc := TStringList.Create;
          LongDesc.Clear;
          LongDesc.AddStrings(meObjLongDesc.Lines);
          ActDesc    := edObjActionDesc.Text;
          TypeFlag   := GetFlagNumber(chlbTypeFlags);
          ExtraBV    := ParseCheckBox(chlbExtraBV);
         // if ExtraBV = '' then ExtraBV := '0';     //Change into numeric 0 instead of a nothing in ascii
          WearBV     := ParseCheckBox(chlbWearBV);
          //if WearBV = ''  then WearBV  := '0';     //Change into numeric 0 instead of a nothing in ascii
          Val(edObjVal0.text,Num,Code);
          If Code <> 0 then Values[0] := 0
             Else Values[0] := Num;
          Val(edObjVal1.text,Num,Code);
          If Code <> 0 then Values[1] := 0
             Else Values[1] := Num;
          Val(edObjVal2.text,Num,Code);
          If Code <> 0 then Values[2] := 0
             Else Values[2] := Num;
          Val(edObjVal3.text,Num,Code);
          If Code <> 0 then Values[3] := 0
             Else Values[3] := Num;

          Val(edObjWeight.text,Num,Code);
          If Code <> 0 then Weight := 0
             Else Weight := Num;
          Val(edObjCost.text,Num,Code);
          If Code <> 0 then Cost := 0
             Else Cost := Num;
          Val(edObjRent.text,Num,Code);
          If Code <> 0 then Rent := 0
             Else Rent := Num;

          //Num := 0;
          Setlength(ExtDesc,Length(ObjExt));
          for i := 0 to Length(ObjExt)-1 do
          Begin
               ExtDesc[i] := ObjExtraDescEquals(ObjExt[i]);
          End;
          {
          Num := 0;
          for i := 1 to 6 do
          Begin
               Val(sgObjAffectFields.Cells[0,i],Num1,Code);
               Val(sgObjAffectFields.Cells[1,i],Num2,Code1);
               if (Code = 0) and (Code1 = 0) then
               Begin
                    inc(Num);
                    AffFields[num].Location := num1;
                    AffFields[num].Value    := num2;
               End;
          End;   }
          //Setlength(AffFields,Length(ObjAF));
          for i := 1 to ObjNrAF do
          Begin
               AffFields[i] :=  ObjAFEquals(ObjAF[i]);
          End;
          NrofAF := ObjNrAF;
     End;
End;

{Returns a Stringlist in mud object file format of an object}
Function TfmCircleEd.RenderObj(Obj : TObj) : TStringList;
Var
   i  : Integer;
Begin
     Result := TStringList.Create;
     With Obj do
     Begin
          //VNum//
          Result.Add('#'+IntToStr(VNum));
          Result.Add(Alias+'~');
          Result.Add(ShortDesc+'~');
          //Result.Add(LongDesc+'~');
          Result.AddStrings(LongDesc);
          Result.Add('~');
          Result.Add(ActDesc+'~');
          if ExtraBV = '' then ExtraBV := '0';
          if WearBV = ''  then WearBV  := '0';
          Result.Add(IntToStr(TypeFlag)+' '+ExtraBV+' '+WearBV);
          Result.Add(IntToStr(Values[0])+' '+IntToStr(Values[1])+' '+IntToStr(Values[2])+' '+IntToStr(Values[3]));
          Result.Add(IntToStr(Weight)+' '+IntToStr(Cost)+' '+IntToStr(Rent));
          if Length(ExtDesc) > 0 then
           for i := 0 to Length(ExtDesc)-1 do
           Begin
                Result.Add('E');
                Result.Add(ExtDesc[i].Keyword+'~');
                Result.AddStrings(ExtDesc[i].Desc);
                Result.Add('~');
           End;
          for i := 1 to NrofAF do
          Begin
               Result.Add('A');
               Result.Add(IntToStr(AffFields[i].Location)+' '+IntToStr(AffFields[i].Value))
          End;
     End;
End;

{Functions that moves Objects[num] to the GUI}
Procedure TfmCircleEd.ObjToGUI(Num : Integer);
Var
   i,
   ind : Integer;
Begin
     CurObj := Num;
     With Objects[Num] do
     Begin
          //VNum
          edObjVNum.Text := IntToStr(VNum);

          //Alias List
          edObjAliasL.Text := Alias;

          //Short Description
          edObjShortDesc.Text := ShortDesc;

          //Long Description
          //edObjLongDesc.Text := LongDesc;
          meObjLongDesc.Clear;
          meObjLongDesc.Lines.AddStrings(LongDesc);

          //Action Description
          edObjActionDesc.Text := ActDesc;


          //Type Flag
          ind := FindNumber(chlbtypeFlags,TypeFlag);
          RadioCheck(ind,chlbtypeFlags);

          //Extra Bitvectors
          for i := 0 to chlbExtraBV.Items.Count-1 do chlbExtraBV.Checked[i] := false;
          for i := 1 to Length(ExtraBV) do
          Begin
               ind := FindString(chlbExtraBV,ExtraBV[i]);
               chlbExtraBV.Checked[ind] := true;
          End;

          //Wear Bitvectors
          for i := 0 to chlbWearBV.Items.Count-1 do chlbWearBV.Checked[i] := false;
          for i := 1 to Length(WearBV) do
          Begin
               ind := FindString(chlbWearBV,WearBV[i]);
               chlbWearBV.Checked[ind] := true;
          End;

          //Value 0-3
          edObjVal0.Text := IntToStr(Values[0]);
          edObjVal1.Text := IntToStr(Values[1]);
          edObjVal2.Text := IntToStr(Values[2]);
          edObjVal3.Text := IntToStr(Values[3]);

          //Weight Gold Rent
          edObjWeight.Text := IntToStr(Weight);
          edObjCost.Text   := IntToStr(Cost);
          edObjRent.Text   := IntToStr(Rent);

          //Extra Descriptions
          lbObjExtraDesc.Clear;
          for i := 0 to Length(ExtDesc)-1 do
          Begin
               //sgObjExtraDesc.Cells[0,i+1] := ExtDesc[i].Keyword;
               //sgObjExtraDesc.Cells[1,i+1] := ExtDesc[i].Desc;
               lbObjExtraDesc.Items.Add(ExtDesc[i].Keyword);
          End;

          SetLength(ObjExt,Length(ExtDesc));
          for i := 0 to Length(ExtDesc)-1 do
              ObjExt[i] := ObjExtraDescEquals(ExtDesc[i]);
          ObjShowExt;

          //Affect Fields
          lbObjAffectFields.Clear;
          for i := 1 to NrofAF do
              ObjAF[i] := ObjAFEquals(AffFields[i]);
          ObjNrAF := NrofAF;
          ObjShowAF;
     End;

End;

{Create a List of objects in the ListBox}
Procedure TfmCircleEd.ShowObjList;
Var
   i : Integer;
Begin
     lbObj.Clear;
     for i := 0 to Length(Objects)-1 do
     Begin
          lbObj.Items.Add(IntToStr(Objects[i].VNum));
     End;
     if lbObj.Items.Count > 0 then
     Begin
          lbObj.Selected[0] := true;
          ObjToGUI(0);
     End;
End;

{Returns the position in the array of a Object VNUM}
Function TfmCircleEd.ObjectPos(Vnum : Integer): Integer;
Var
   i  : Integer;
Begin
     Result := -1;  //If not found return -1
     for i := 0 to Length(Objects)-1 do
     Begin
          if Objects[i].Vnum = VNum then
          Begin
               Result := i;
               Exit;
          End;
     End;
End;

{Creates a new Object in array and returns its position in array}
Function TfmCircleEd.NewObj(VNum : Integer) : Integer ;
Begin
     Result := Length(Objects);
     SetLength(Objects,Result+1);
     Objects[Result].Vnum := VNum;
     Objects[Result].TypeFlag := 1;
     Objects[Result].WearBV   := 'a'; //you'll probably want to take it
     Objects[Result].Alias := 'new object';
     Objects[Result].ShortDesc := 'new object';
     Objects[Result].LongDesc := TStringList.Create;
     Objects[Result].LongDesc.Text := 'A new object.';
End;

{Load object file, Parse It, show the list}
Procedure TfmCircleEd.LoadObjects(Leer : String);
Begin
     //ShowMessage('Loading Objects');
     pgMain.ActivePageIndex := 0;
     ObjFile.LoadFromFile(leer);
     Label1.Caption := extractfilename(leer);
     BuildObjList;
     ShowObjList;
     ObjZone := (Objects[0].Vnum div 100);
     ObjFile.Clear;
End;

{sort object according to VNums}
Procedure TfmCircleEd.ObjSort;
Var
   i,j : Integer;
   TempObj : TObj;
Begin
     for i := 0 to Length(Objects)-1 do
     Begin
          for j := i+1 to Length(Objects)-1 do
          Begin
               if Objects[i].Vnum > Objects[j].Vnum then
               Begin
                    TempObj := ObjEquals(Objects[i]);
                    Objects[i] := ObjEquals(Objects[j]);
                    Objects[j] := ObjEquals(TempObj);
               End;
          End;
     End;
End;

{put extra description into listbox}
Procedure TfmCircleEd.ObjShowExt;
var
   i : Integer;
Begin
     lbObjExtraDesc.Clear;
     for i := 0 to Length(ObjExt)-1 do
     Begin
          lbObjExtraDesc.Items.Add(ObjExt[i].Keyword)
     End;

End;

{put Affection fields into listbox}
Procedure TfmCircleEd.ObjShowAF;
var
   i : Integer;
   Line : String;
Begin
     lbObjAffectFields.Clear;
     for i := 1 to ObjNrAF do
     Begin
          Line := StringConv('Object_AffectFlag', ObjAF[i].Location);
          lbObjAffectFields.Items.Add(Line);
     End;

End;



{=====END OBJECTS======}



{-----------------}
{MOBILE PROCEDURES}
{-----------------}

{Load mobile from file parse put everwhere and show}
Procedure TfmCircleEd.LoadMobiles(Leer : String);
Begin
     //ShowMessage('Loading Mobiles');
     pgMain.ActivePageIndex := 1;
     MobFile.LoadFromFile(leer);
     Label18.Caption := extractfilename(leer);
     BuildMobList;
     ShowMobList;
     if Length(Mobiles) > 0 then
        MobZone := (Mobiles[0].Vnum div 100);
     MobFile.Clear;
End;

{put E Specs into listbox }
Procedure TfmCircleEd.MobShowES;
var
   i : Integer;
Begin
     lbMobESpecs.Clear;
     for i := 0 to Length(MobES)-1 do
     Begin
          lbMobESpecs.Items.Add(MobES[i].Spec);
     End;

end;

{return record with the X, Y & Z values and check for valid numbers} 
Function ExtractXYZ(Line : String) : TXYZ;
Var
   p1,p2,p3 : String;
   Code,Num : integer;
Begin
     Line[Pos('d',line)] := ' ';
     Line[Pos('+',line)] := ' ';
     GetParams(line,[@p1,@p2,@p3]);
     Val(p1,num,code);
     if code <> 0 then Result.X := 0
     else Result.X := num;
     Val(p2,num,code);
     if code <> 0 then Result.Y := 0
     else Result.Y := num;
     Val(p3,num,code);
     if code <> 0 then Result.Z := 0
     else Result.Z := num;

End;

{read mobile file and put into memeory}
Function TfmCircleEd.BuildMobList : Integer;
Var
   Num,
   Num1,
   Num2,
   Num3,
   Code,
   Code1,
   Code2,
   NrofMob,
   i       : Integer;
   Lmode   : Integer;
   Mobtype,
   p,p1,p2,p3,p4,
   Line    : String;
Begin
     i       := 0;
     NrofMob := 0;
     LMode   := 0; //Not in Mobile
     SetLength(Mobiles,0);
     Num3    := 0;

     Repeat
           Line := MobFile.Strings[i];
           if StartWith('$',Line) then Lmode := -1;
           Case LMode of
           -1 : begin end;
            0 : if (StartWith('#',Line)) and (Line <> '') then        // Not in a Mobiles right now
                Begin
                     GetParams(Line,[@p1]);
                     delete(p1,1,1);
                     Val(p1,Num,Code);
                     if Code = 0 then
                     Begin
                          //Check for duplicate VNum's
                          inc(NrofMob);
                          SetLength(Mobiles,NrofMob);
                          Mobiles[NrofMob-1].Vnum := Num;
                          Mobiles[NrofMob-1].LongDesc   := TStringList.Create; //Create LongDesc
                          Mobiles[NrofMob-1].DetailDesc := TStringList.Create; //Create DetailDesc
                          Lmode := 1; // In object Next Alias;
                     End;
                End;
            1 : Begin  //Alias List
                     Num := Pos('~',Line);
                     if Num = 0 then Mobiles[NrofMob-1].Alias := Mobiles[NrofMob-1].Alias + Line
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                          //p1 := Trimright(p1);
                          Mobiles[NrofMob-1].Alias := Mobiles[NrofMob-1].Alias + p1;
                          Lmode := 2; //Next Short Description
                     End;
                End;
            2 : Begin  //Short Description
                     Num := Pos('~',Line);
                     if Num = 0 then Mobiles[NrofMob-1].ShortDesc := Mobiles[NrofMob-1].ShortDesc + Line
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                         // p1 := Trimright(p1);
                          Mobiles[NrofMob-1].ShortDesc := Mobiles[NrofMob-1].ShortDesc + p1;
                          Lmode := 3; //Next Long Description
                     End;
                End;
            3 : Begin  //Long Description
                     Num := Pos('~',Line);
                     if Num = 0 then Mobiles[NrofMob-1].LongDesc.Add(Line)
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                        //  p1 := Trimright(p1);
                          Mobiles[NrofMob-1].LongDesc.Add(p1);
                          Lmode := 4; //Next Action Description
                     End;
                End;
            4 : Begin  //Detailed Description
                     Num := Pos('~',Line);
                     if Num = 0 then Mobiles[NrofMob-1].DetailDesc.Add(Line)
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                        //  p1 := Trimright(p1);
                          Mobiles[NrofMob-1].DetailDesc.Add(p1);
                          Lmode := 5; //Next Action Description
                     End;
                End;
            5 : if (Line <> '') then //<action bitvector> <affection bitvector> <alignment> <type flag>
                Begin
                     if GetParams(Line,[@p,@p1,@p2,@p3]) >= 4 then
                     Begin
                          Val(p ,Num ,Code);
                          Val(p1,Num1,Code1);
                          Val(p2,Num2,Code2);
                          If (Code2 = 0) then //The Alignment must be a number
                          Begin
                               if Code = 0 then
                               Begin
                                    p := ConvertNumS('Mobile_ActionBV',num);
                               End;
                               Mobiles[NrofMob-1].ActionBV := p;
                               if Code1 = 0 then
                               Begin
                                    p1 := ConvertNumS('Mobile_AffectionBV',num1);
                               End;
                               Mobiles[NrofMob-1].AffectBV := p1;
                               Mobiles[NrofMob-1].Alignment := num2;
                               Mobiles[NrofMob-1].TypeFlag := p3;
                               MobType := p3;
                               LMode := 6; //<level> <thac0> <armor class> <max hit points> <bare hand damage>
                          End;
                     End;
                End;
            6 : if (Line <> '') then //<level> <thac0> <armor class> <max hit points> <bare hand damage>
                Begin
                     if GetParams(Line,[@p,@p1,@p2,@p3,@p4]) >= 5 then
                     Begin
                          Val(p ,Num ,Code);
                          Val(p1,Num1,Code1);
                          Val(p2,Num2,Code2);

                          If (Code  = 0) and
                             (Code1 = 0) and
                             (Code2 = 0) then //The <level> <thac0> <armor class> must be numbers
                          Begin
                               Mobiles[NrofMob-1].level    := Num;
                               Mobiles[NrofMob-1].Thac0    := Num1;
                               Mobiles[NrofMob-1].AC       := Num2;
                               Mobiles[NrofMob-1].hitpoint := ExtractXYZ(p3);
                               Mobiles[NrofMob-1].BHD      := ExtractXYZ(p4);
                               LMode := 7; //<gold> <experience points>
                          End;
                     End;
                End;
            7 : if (Line <> '') then //<gold> <experience points>
                Begin
                     if GetParams(Line,[@p,@p1]) >= 2 then
                     Begin
                          Val(p ,Num ,Code);
                          Val(p1,Num1,Code1);
                          If (Code  = 0) and
                             (Code1 = 0) then //The <gold> <experience points> must be numbers
                          Begin
                               Mobiles[NrofMob-1].gold       := Num;
                               Mobiles[NrofMob-1].Experience := Num1;
                               LMode := 8; //<load position> <default position> <sex>
                          End;
                     End;
                End;
            8 : if (Line <> '') then //<load position> <default position> <sex>
                Begin
                     if GetParams(Line,[@p,@p1,@p2]) >= 3 then
                     Begin
                          Val(p ,Num ,Code);
                          Val(p1,Num1,Code1);
                          Val(p2,Num2,Code2);
                          If (Code  = 0) and
                             (Code1 = 0) and
                             (Code2 = 0) then //The <load position> <default position> <sex> must be numbers
                          Begin
                               Mobiles[NrofMob-1].LoadPos    := Num;
                               Mobiles[NrofMob-1].DefaultPos := Num1;
                               Mobiles[NrofMob-1].Sex        := Num2;
                               If MobType = 'E' then
                               Begin
                                    LMode := 9; //Nect E-Specs
                                    Num3  := 0;
                               End
                               else LMode := 0;   //if it is s it must be the end
                          End;
                     End;
                End;
            9 : if (Line <> '') then //E Specs
                Begin
                     if GetParams(Line,[@p,@p1]) >= 2 then
                     Begin
                          Val(p1,Num1,Code1);
                          If (Code1 = 0) and (p <> 'E') then //The value must be a number
                          Begin
                               inc(num3);
                               SetLength(Mobiles[NrofMob-1].ESpecs ,num3);
                               if pos(':',p) <> 0 then SetLength(p,Length(p)-1);//delete ':'

                               Mobiles[NrofMob-1].ESpecs[num3-1].Spec := p;
                               Mobiles[NrofMob-1].ESpecs[num3-1].Value := num1;
                               //Repeat until E
                          End;
                     End;
                     if p = 'E' then LMode := 0;
                End;
           End;//end Case
           inc(i);
     Until (i = MobFile.Count) or (Lmode = -1); //i should be pass ObjFile.Count-1
     Result := i-1;
End;

{Put list of mobiles into listbox}
Procedure TfmCircleEd.ShowMobList;
Var
   i : Integer;
Begin
     lbMob.Clear;
     for i := 0 to Length(Mobiles)-1 do
     Begin
          lbMob.Items.Add(IntToStr(Mobiles[i].VNum));
     End;
     if lbMob.Items.Count > 0 then
     Begin
          lbMob.Selected[0] := true;
          MobToGUI(0);
     End;
End;

{Show mobile[num] in GUI}
Procedure TfmCircleEd.MobToGUI(Num : integer);
Var
   i,
   ind : Integer;
Begin
     CurMob := Num;
     With Mobiles[Num] do
     Begin
          edMobVNum.Text      := IntToStr(VNum);   //VNUM
          edMobjAliasL.Text   := Alias;            //Alias List
          edMobShortDesc.Text := ShortDesc;        //Short Description
          rgMobSex.ItemIndex  := Sex;              //Sex
          seMobAlign.Value    := Alignment;        //Alignment
          seMobLvl.Value      := Level;            //Level
          seMovThac0.Value    := Thac0;            //Thac0
          seMobArmor.Value    := AC;               //Armor

          seMobHPX.Value      := hitpoint.X;       //Max hitpoints
          seMobHPY.Value      := hitpoint.Y;
          seMobHPZ.Value      := hitpoint.Z;

          seMobBHDX.Value     := BHD.X;            //Bare handed damage
          seMobBHDY.Value     := BHD.Y;
          seMobBHDZ.Value     := BHD.Z;

          seMobGold.Value     := Gold;             //Gold
          seMobExp.Value      := Experience;       //Experience

          meMobLongDesc.Clear;                     //Long Description
          meMobLongDesc.Lines.AddStrings(LongDesc);
          meMobDetailDesc.Clear;                   //Detailed Description
          meMobDetailDesc.Lines.AddStrings(DetailDesc);
          if TypeFlag = 'E' then rbMobE.Checked := true
          else rbMobS.Checked := true;            //Mobile Type
          rbMobSClick(Self);

          ind := FindNumber(chlbMobLoadPos,LoadPos);       //Load Position
          RadioCheck(ind,chlbMobLoadPos);

          ind := FindNumber(chlbMobDefaultPos,LoadPos);    //Default Position
          RadioCheck(ind,chlbMobDefaultPos);

          //Action Bit Vectors
          for i := 0 to chlbMobActionBV.Items.Count-1 do chlbMobActionBV.Checked[i] := false;
          for i := 1 to Length(ActionBV) do
          Begin
               ind := FindString(chlbMobActionBV,ActionBV[i]);
               chlbMobActionBV.Checked[ind] := true;
          End;

          //Affection Bit Vectors
          for i := 0 to chlbMobAffectionBV.Items.Count-1 do chlbMobAffectionBV.Checked[i] := false;
          for i := 1 to Length(AffectBV) do
          Begin
               ind := FindString(chlbMobAffectionBV,AffectBV[i]);
               chlbMobAffectionBV.Checked[ind] := true;
          End;
          
          SetLength(MobES,Length(ESpecs));
          for i := 0 to Length(ESpecs)-1 do
              MobES[i] := MobESEquals(ESpecs[i]);
          MobShowES;

     End;
End;

{Returns the position in the array of a Mobile VNUM}
Function TfmCircleEd.MobilePos(Vnum : Integer): Integer;
Var
   i  : Integer;
Begin
     Result := -1;  //If not found return -1
     for i := 0 to Length(Mobiles)-1 do
     Begin
          if Mobiles[i].Vnum = VNum then
          Begin
               Result := i;
               Exit;
          End;
     End;
End;

{Create new mobile and assign default values}
Function TfmCircleEd.NewMob(VNum : Integer) : Integer ;
Begin
     Result := Length(Mobiles);
     SetLength(Mobiles,Result+1);
     Mobiles[Result].Vnum := VNum;
     Mobiles[Result].LoadPos := 8;   //Standing
     Mobiles[Result].DefaultPos := 8;
     Mobiles[Result].TypeFlag := 'S';
     Mobiles[Result].Alias := 'new mobile';
     Mobiles[Result].ShortDesc := 'a New Mobile';
     Mobiles[Result].LongDesc := TStringList.Create;
     Mobiles[Result].LongDesc.Text := 'A new mobile.';
     Mobiles[Result].DetailDesc := TStringList.Create;
     Mobiles[Result].DetailDesc.Text := 'A new mobile.';
End;

{Equals one mobile to another}
Function TfmCircleEd.MobEquals(OldMob : TMob) : TMob;
Var
   j : Integer;
Begin
     With Result do
     Begin
          Vnum        := OldMob.Vnum;
          Alias       := OldMob.Alias;
          ShortDesc   := OldMob.ShortDesc;

          ActionBV    := OldMob.ActionBV;
          AffectBV    := OldMob.AffectBV;
          Alignment   := OldMob.Alignment;
          TypeFlag    := OldMob.TypeFlag;
          Level       := OldMob.Level;
          Thac0       := OldMob.Thac0;
          AC          := OldMob.AC;

          Gold        := OldMob.Gold;
          Experience  := OldMob.Experience;
          LoadPos     := OldMob.LoadPos;
          DefaultPos  := OldMob.DefaultPos;
          Sex         := OldMob.Sex;

          Hitpoint.X   := OldMob.hitpoint.X;
          Hitpoint.Y   := OldMob.hitpoint.Y;
          Hitpoint.Z   := OldMob.hitpoint.Z;
          BHD.X        := OldMob.BHD.X;
          BHD.Y        := OldMob.BHD.Y;
          BHD.Z        := OldMob.BHD.Z;

          LongDesc    := TStringList.Create;
          LongDesc.AddStrings(OldMob.LongDesc);
          DetailDesc  := TStringList.Create;
          DetailDesc.AddStrings(OldMob.DetailDesc);

          SetLength(ESpecs,0);
          SetLength(ESpecs,Length(OldMob.ESpecs));
          for j := 0 to Length(OldMob.ESpecs)-1 do
          Begin
               ESpecs[j].Spec := OldMob.ESpecs[j].Spec;
               ESpecs[j].Value := OldMob.ESpecs[j].Value;
          End;
     End;
End;

{Save change of mob in gui to memory}
Function TfmCircleEd.MobGUItoMem : TMob;
var
   i : integer;
Begin
     With Result do
     Begin
          Vnum        := StrToInt(edMobVnum.Text);
          Alias       := edMobjAliasL.Text;
          ShortDesc   := edMobShortDesc.Text;
          ActionBV    := ParseCheckBox(chlbMobActionBV);
          AffectBV    := ParseCheckBox(chlbMobAffectionBV);
          Alignment   := seMobAlign.Value;

          Level       := seMobLvl.Value;
          Thac0       := seMovThac0.Value;
          AC          := seMobArmor.Value;
          Gold        := seMobGold.Value;
          Experience  := seMobExp.Value;
          LoadPos     := GetFlagNumber(chlbMobLoadPos);
          DefaultPos  := GetFlagNumber(chlbMobDefaultPos);;
          Sex         := rgMobSex.ItemIndex;

          LongDesc    := TStringList.Create;
          LongDesc.AddStrings(meMobLongDesc.Lines);

          DetailDesc  := TStringList.Create;
          DetailDesc.AddStrings(meMobDetailDesc.Lines);

          if rbMobS.Checked then TypeFlag := 'S'
          else TypeFlag := 'E';

          Hitpoint.X  := seMobHPX.Value;
          Hitpoint.Y  := seMobHPY.Value;
          Hitpoint.Z  := seMobHPZ.Value;

          BHD.X  := seMobBHDX.Value;
          BHD.Y  := seMobBHDY.Value;
          BHD.Z  := seMobBHDZ.Value;


          Setlength(ESpecs,Length(MobES));
          for i := 0 to Length(ESpecs)-1 do
          Begin
               ESpecs[i] := MobESEquals(MobES[i]);
          End;

     End;
End;

{Returns a string list of mobile in circle .mob format}
Function TfmCircleEd.RenderMob(Mob : TMob) : TStringList;
Var
   i : Integer;
Begin
     Result := TStringList.Create;
     With Mob do
     Begin
          Result.Add('#'+IntToStr(VNum));
          Result.Add(Alias+'~');
          Result.Add(ShortDesc+'~');
          Result.AddStrings(LongDesc);
          Result.Add('~');
          Result.AddStrings(DetailDesc);
          Result.Add('~');
          if ActionBV = '' then ActionBV := '0';
          if AffectBV = '' then AffectBV  := '0';
          Result.Add(ActionBV+' '+AffectBV+' '+IntToStr(Alignment)+' '+TypeFlag);
          Result.Add( IntToStr(Level)+' '+IntToStr(Thac0)+' '+IntToStr(AC)+' '+
                      IntToStr(Hitpoint.X)+'d'+IntToStr(Hitpoint.Y)+'+'+IntToStr(Hitpoint.Z)+' '+
                      IntToStr(BHD.X)+'d'+IntToStr(BHD.Y)+'+'+IntToStr(BHD.Z)+' ' );
          Result.Add(IntToStr(Gold)+' '+IntToStr(Experience));
          Result.Add(IntToStr(LoadPos)+' '+IntToStr(DefaultPos)+' '+IntToStr(Sex));
          if TypeFlag = 'E' then
          Begin
               For i := 0 to Length(ESpecs)-1 do
               Begin
                    Result.Add(ESpecs[i].Spec+': '+IntToStr(ESpecs[i].Value));
               End;
               Result.Add('E');
          End;

     End;
End;

{sort mobiles from vnum}
Procedure TfmCircleEd.MobSort;
Var
   i,j : Integer;
   TempMob : TMob;
Begin
     for i := 0 to Length(Mobiles)-1 do
     Begin
          for j := i+1 to Length(Mobiles)-1 do
          Begin
               if Mobiles[i].Vnum > Mobiles[j].Vnum then
               Begin
                    TempMob    := MobEquals(Mobiles[i]);
                    Mobiles[i] := MobEquals(Mobiles[j]);
                    Mobiles[j] := MobEquals(TempMob);
               End;
          End;
     End;
End;



{=====END MOBILES======}


{-----------------}
{WORLD PROCEDURES}
{-----------------}

Procedure TfmCircleEd.LoadWorlds(Leer : String);
Begin
     //ShowMessage('Loading Worlds');
     pgMain.ActivePageIndex := 2;
     WldFile.LoadFromFile(leer);
     Label42.Caption := extractfilename(leer);
     BuildWldList;
     ShowWldList;
     //ShowWldGrid;
     if Length(Worlds) > 0 then
        WldZone := (Worlds[0].Vnum div 100);
     WldFile.Clear;
End;

{
 //Oneday create and show map like presentation of world
Function VNumInList(Var TheList : Array of integer; Vnum : integer) : boolean;
Var
   i : Integer;
Begin
     Result := false;
     for i := 0 to length(TheList) do
         if TheList[i] = Vnum then
     Begin
          Result := True;
          Exit;
     End;
End;

Procedure TfmCircleEd.BuildWldGrid;
Var
   i,RoomVnum,
   MinX,MinY,
   MaxX,MaxY  : Integer;

Begin
     //          y N
     //          ^
     //   W -x <   > x  E
     //          v
     //         -y S
     MinX := 0;
     RoomVNum := Worlds[0].Vnum;
     Repeat
           for i := 0 to Length(Worlds[WorldPos(RoomVnum)].DirectionF) do
           Begin

           End;

     Until VNumInList(VNumCheck,RoomVnum);
End;

Procedure TfmCircleEd.ShowWldGrid;
Begin
     //
End; }

{put extra description in listbox}
Procedure TfmCircleEd.WldShowExt;
var
   i : Integer;
Begin
     lbWldED.Clear;
     for i := 0 to Length(WldExt)-1 do
     Begin
          lbWldED.Items.Add(WldExt[i].Keyword)
     End;

End;

{put exit direction in listbox}
Procedure TfmCircleEd.WldShowDir;
Var

   DirN : String;
   Ind,
   i,j  : Integer;

Begin
     lbWldDirF.Items.Clear;
     ind := -1;
     for i := 0 to Length(Constants)-1 do
     Begin
          if Constants[i].ConName = 'World_ExitDirection' then
          Begin
               ind := i;
               break;
          End;
     End;
     If ind = -1 then
     Begin
          ShowMessage('Constant not found');
          Exit;
     End;
     for i := 0 to Length(WldDir)-1 do
     Begin
          DirN := '';
          for j := 0 to Length(Constants[ind].Values)-1 do
          Begin
               if Constants[ind].Values[j].Flag = WldDir[i].DirNum then
               Begin
                    DirN := Constants[ind].Values[j].Text;
                    break;
               End;
          End;

          lbWldDirF.Items.Add(DirN+': '+IntToStr(WldDir[i].RoomLinked) )
     End;
End;

{put world in gui}
Procedure TfmCircleEd.WldToGUI(Num : integer);
Var
   i,
   ind : Integer;

Begin
     CurWld := Num;
     With Worlds[Num] do
     Begin
          edWldVNum.Text      := IntToStr(VNum);   //VNUM
          edWldZone.Text      := IntToStr(ZoneNum);
          edWldRoomName.Text  := RoomName;        //Short Description

          meWldRoomDesc.Clear;                     //Long Description
          meWldRoomDesc.Lines.AddStrings(RoomDesc);
          meWldRoomDesc.SelStart := 0;
          ind := FindNumber(chlbWldSectorFlag,SectorType);       //Load Position
          RadioCheck(ind,chlbWldSectorFlag);

          //Room Bit Vectors
          for i := 0 to chlbWldRoomBV.Items.Count-1 do chlbWldRoomBV.Checked[i] := false;
          for i := 1 to Length(RoomBV) do
          Begin
               ind := FindString(chlbWldRoomBV,RoomBV[i]);
               chlbWldRoomBV.Checked[ind] := true;
          End;
          //Direction Fields
          SetLength(WldDir,Length(DirectionF));
          for i := 0 to Length(DirectionF)-1 do
              WldDir[i] := DirFieldEquals(DirectionF[i]);
          WldShowDir;
          
          //Extra Descriptions
          SetLength(WldExt,Length(ExtraDesc));
          for i := 0 to Length(ExtraDesc)-1 do
              WldExt[i] := WldExtraDescEquals(ExtraDesc[i]);
          WldShowExt;
     End;
End;

{parse world file}
Function TfmCircleEd.BuildWldList : Integer;
Var
   Num,
   Num1,
   Num2,
   Num3,
   Code,
   Code1,
   Code2,
   NrofWld,
   i       : Integer;
   Lmode   : Integer;
   p,p1,p2,
   Line    : String;
Begin
     i       := 0;
     NrofWld := 0;
     LMode   := 0; //Not in Mobile
     SetLength(Worlds,0);

     Repeat
           Line := WldFile.Strings[i];
           if StartWith('$',Line) then Lmode := -1;
           Case LMode of
           -1 : begin end;
            0 : if (StartWith('#',Line)) and (Line <> '') then        // Not in a Mobiles right now
                Begin
                     GetParams(Line,[@p1]);
                     delete(p1,1,1);
                     Val(p1,Num,Code);
                     if Code = 0 then
                     Begin
                          //Check for duplicate VNum's
                          inc(NrofWld);
                          SetLength(Worlds,NrofWld);
                          Worlds[NrofWld-1].Vnum := Num;
                          Worlds[NrofWld-1].RoomDesc   := TStringList.Create; //Create RoomDesc
                          Lmode := 1; // In room name next
                     End;
                End;
            1 : Begin  //Room name
                     Num := Pos('~',Line);
                     if Num = 0 then Worlds[NrofWld-1].RoomName := Worlds[NrofWld-1].RoomName + Line
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                          //p1 := Trimright(p1);
                          Worlds[NrofWld-1].RoomName := Worlds[NrofWld-1].RoomName + p1;
                          Lmode := 2; //Next Room Description
                     End;
                End;
            2 : Begin  //Room Description
                     Num := Pos('~',Line);
                     if Num = 0 then Worlds[NrofWld-1].RoomDesc.Add(Line)
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                          Worlds[NrofWld-1].RoomDesc.Add(p1);
                          Lmode := 3; //Next <zone number> <room bitvector> <sector type>
                     End;
                End;

            3 : if (Line <> '') then //<zone number> <room bitvector> <sector type>
                Begin
                     if GetParams(Line,[@p,@p1,@p2]) >= 3 then
                     Begin
                          Val(p ,Num ,Code);
                          Val(p1,Num1,Code1);
                          Val(p2,Num2,Code2);
                          If (Code  = 0) and
                             (Code2 = 0) then //The Zone and Sector must be numbers
                          Begin
                               Worlds[NrofWld-1].ZoneNum := Num;
                               if Code1 = 0 then
                               Begin
                                    p1 := ConvertNumS('World_RoomBV',num1); //Just assuming this works
                               End;
                               Worlds[NrofWld-1].RoomBV := p1;
                               Worlds[NrofWld-1].SectorType := num2;
                               LMode := 4; {zero or more direction fields and/or extra descriptions}
                          End;
                     End;
                End;
            4 : if (Line <> '') then //{zero or more direction fields and/or extra descriptions}
                Begin
                     if GetParams(Line,[@p1]) >= 1 then
                     Begin
                          if StartWith('D',p1) then
                          Begin
                               num := Length(Worlds[NrofWld-1].DirectionF);
                               SetLength(Worlds[NrofWld-1].DirectionF,num+1);
                               Worlds[NrofWld-1].DirectionF[num].GenDesc := TStringList.Create;
                               Delete(p1,1,1);
                               Val(p1,num2,code);
                               if Code = 0 then
                               Begin
                                    Worlds[NrofWld-1].DirectionF[num].DirNum := num2;
                                    Lmode := 5; //Directions Gen Desc
                               End;
                          End;
                          if (p1='E') then
                          Begin
                               num := Length(Worlds[NrofWld-1].ExtraDesc);
                               SetLength(Worlds[NrofWld-1].ExtraDesc,num+1);
                               Worlds[NrofWld-1].ExtraDesc[num].Desc := TStringList.Create;
                               Lmode := 8; //Extra Desc key words
                          End;

                          if p1 = '$' then Lmode := -1; //Finished
                          if Startwith('#',p1) then     // new object
                          Begin
                               dec(i);                  //go back one line
                               Lmode := 0;              //and start on nect object
                          End;
                     End;
                End;
            5 : Begin  //Directions Gen Desc
                     Num  := Pos('~',Line);
                     Num1 := Length(Worlds[NrofWld-1].DirectionF);
                     if Num = 0 then Worlds[NrofWld-1].DirectionF[num1-1].GenDesc.Add(line)
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                          Worlds[NrofWld-1].DirectionF[num1-1].GenDesc.Add(p1);
                          Lmode := 6; //Next Keyword List
                     End;
                End;
            6 : Begin //Keyword List
                     Num  := Pos('~',Line);
                     Num1 := Length(Worlds[NrofWld-1].DirectionF);
                     if Num = 0 then Worlds[NrofWld-1].DirectionF[num1-1].Keywords := Worlds[NrofWld-1].DirectionF[num1-1].Keywords + Line+#13
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                          p1 := Trimright(p1);
                          Worlds[NrofWld-1].DirectionF[num1-1].Keywords := Worlds[NrofWld-1].DirectionF[num1-1].Keywords + p1;
                          Lmode := 7; //Next <door flag> <key number> <room linked>
                     End;
                End;
            7 : if (Line <> '') then //<door flag> <key number> <room linked>
                Begin
                     Num3 := Length(Worlds[NrofWld-1].DirectionF);
                     if GetParams(Line,[@p,@p1,@p2]) >= 3 then
                     Begin
                          Val(p ,Num ,Code);
                          Val(p1,Num1,Code1);
                          Val(p2,Num2,Code2);
                          If (Code  = 0) and
                             (Code1 = 0) and
                             (Code2 = 0) then //The <door flag> <key number> <room linked> must be numbers
                          Begin
                               Worlds[NrofWld-1].DirectionF[num3-1].DoorFlag   := num;
                               Worlds[NrofWld-1].DirectionF[num3-1].KeyNum     := num1;
                               Worlds[NrofWld-1].DirectionF[num3-1].RoomLinked := num2;
                               Lmode := 4; //back to zero or more direction fields and/or extra descriptions
                          End;
                     End;
                End;
            8 : Begin //Extra Desc key words
                     Num  := Pos('~',Line);
                     Num1 := Length(Worlds[NrofWld-1].ExtraDesc);
                     if Num = 0 then Worlds[NrofWld-1].ExtraDesc[num1-1].Keyword := Worlds[NrofWld-1].ExtraDesc[num1-1].Keyword + Line+#13
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                          p1 := Trimright(p1);
                          Worlds[NrofWld-1].ExtraDesc[num1-1].Keyword := Worlds[NrofWld-1].ExtraDesc[num1-1].Keyword + p1;
                          Lmode := 9; //Next Extra description text
                     End;
                End;
            9 : Begin  //Directions Gen Desc
                     Num  := Pos('~',Line);
                     Num1 := Length(Worlds[NrofWld-1].ExtraDesc);
                     if Num = 0 then Worlds[NrofWld-1].ExtraDesc[num1-1].Desc.Add(line)
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                          Worlds[NrofWld-1].ExtraDesc[num1-1].Desc.Add(p1);
                          Lmode := 4; //Next Keyword List
                     End;
                End;

           End;//end Case
           inc(i);
     Until (i = WldFile.Count) or (Lmode = -1); //i should be pass WldFile.Count-1
     Result := i-1;
End;

{Returns the position in the array of a Mobile VNUM}
Function TfmCircleEd.WorldPos(Vnum : Integer): Integer;
Var
   i  : Integer;
Begin
     Result := -1;  //If not found return -1
     for i := 0 to Length(Worlds)-1 do
     Begin
          if Worlds[i].Vnum = VNum then
          Begin
               Result := i;
               Exit;
          End;
     End;
End;

{put list of rooms in listbox}
Procedure TfmCircleEd.ShowWldList;
Var
   i : Integer;
Begin
     lbWld.Clear;
     for i := 0 to Length(Worlds)-1 do
     Begin
          lbWld.Items.Add(IntToStr(Worlds[i].VNum));
     End;
     if lbWld.Items.Count > 0 then
     Begin
          lbWld.Selected[0] := true;
          WldToGUI(0);
     End;
End;

{create new world and assign defalt values}
Function TfmCircleEd.NewWld(VNum : Integer) : Integer ;
Begin
     Result := Length(Worlds);
     SetLength(Worlds,Result+1);
     Worlds[Result].Vnum := VNum;
     Worlds[Result].SectorType := 0;
     Worlds[Result].RoomName := 'Somewhere';
     Worlds[Result].RoomDesc := TStringList.Create;
     Worlds[Result].RoomDesc.Text := 'This must be somewhere';
     Worlds[Result].ZoneNum := WldZone;
     SetLength(WldDir,0);
     SetLength(WldExt,0);
End;

{equal one room to another}
Function TfmCircleEd.WldEquals(OldWld : TWld) : TWld;
Var
   j : Integer;
Begin
     With Result do
     Begin
          Vnum        := OldWld.Vnum;
          RoomName    := OldWld.RoomName;

          ZoneNum     := OldWld.ZoneNum;
          RoomBV      := OldWld.RoomBV;
          SectorType  := OldWld.SectorType;

          GridPos.X   := -1;
          GridPos.Y   := -1;

          RoomDesc    := TStringList.Create;
          RoomDesc.AddStrings(OldWld.RoomDesc);

          SetLength(DirectionF,Length(OldWld.DirectionF));
          for j := 0 to Length(OldWld.DirectionF) -1 do
              DirectionF[j]  := DirFieldEquals(OldWld.DirectionF[j]);

          SetLength(ExtraDesc,Length(OldWld.ExtraDesc));
          for j := 0 to Length(OldWld.ExtraDesc) -1 do
              ExtraDesc[j]  := WldExtraDescEquals(OldWld.ExtraDesc[j]);

     End;
End;

{ retuns a world from gui}
Function TfmCircleEd.WldGUItoMem : TWld;
var
   i : integer;
Begin
     With Result do
     Begin
          Vnum        := StrToInt(edWldVnum.Text);
          RoomName    := edWldRoomName.Text;
          RoomDesc    := TStringList.Create;
          RoomDesc.AddStrings(meWldRoomDesc.Lines);

          RoomBV      := ParseCheckBox(chlbWldRoomBV);
          Sectortype  := GetFlagNumber(chlbWldSectorFlag);

          SetLength(DirectionF,Length(WldDir));
          for i := 0 to Length(WldDir) -1 do
              DirectionF[i]  := DirFieldEquals(WldDir[i]);

          SetLength(ExtraDesc,Length(WldExt));
          for i := 0 to Length(WldExt) -1 do
              ExtraDesc[i]  := WldExtraDescEquals(WldExt[i]);
     End;
End;

{sort worlds by vnum}
Procedure TfmCircleEd.WldSort;
Var
   i,j : Integer;
   TempWld : TWld;
Begin
     for i := 0 to Length(Worlds)-1 do
     Begin
          for j := i+1 to Length(Worlds)-1 do
          Begin
               if Worlds[i].Vnum > Worlds[j].Vnum then
               Begin
                    TempWld   := WldEquals(Worlds[i]);
                    Worlds[i] := WldEquals(Worlds[j]);
                    Worlds[j] := WldEquals(TempWld);
               End;
          End;
     End;
End;

{return stringlist of world in circle format}
Function TfmCircleEd.RenderWld(Wld : TWld) : TStringList;
Var
   i : Integer;
Begin
     Result := TStringList.Create;
     With Wld do
     Begin
          Result.Add('#'+IntToStr(VNum));
          Result.Add(RoomName+'~');
          Result.AddStrings(RoomDesc);
          Result.Add('~');

          if RoomBV = '' then RoomBV := '0'; //Placeholder
          Result.Add(IntToStr(ZoneNum)+' '+RoomBV+' '+IntToStr(SectorType));
          if Length(DirectionF) > 0 then
          Begin
               for i := 0 to Length(DirectionF)-1 do
               Begin
                    Result.Add('D'+IntToStr(DirectionF[i].DirNum) );
                    Result.AddStrings(DirectionF[i].GenDesc);
                    Result.Add('~');
                    Result.Add(DirectionF[i].Keywords+'~');
                    Result.Add(IntToStr(DirectionF[i].DoorFlag)+' '+IntToStr(DirectionF[i].KeyNum)+' '+IntToStr(DirectionF[i].RoomLinked));
               End;
          End;
          If Length(ExtraDesc) > 0 then
          Begin
               for i := 0 to Length(ExtraDesc)-1 do
               Begin
                    Result.Add('E');
                    Result.Add(ExtraDesc[i].Keyword+'~');
                    Result.AddStrings(ExtraDesc[i].Desc);
                    Result.Add('~');
               End;
          End;
     End;
End;


{=====END WORLD======}


{-----------------}
{ZONES PROCEDURES}
{-----------------}

{Show zone name and other info in gui}
Procedure TfmCircleEd.ShowZoneInfo;
Begin
    // if ZonZone = -1 then exit;
     edZonVNum.Text       := IntToStr(Zone.VNum);
     edZonName.Text       := Zone.ZoneName;
     seZonBotRoom.Value   := Zone.BottomRoom;
     seZonTopRoom.Value   := Zone.TopRoom;
     seZonLifespan.Value  := Zone.LifeSpan;
     cbZonReset.ItemIndex := Zone.ResetMode;
     edZonCom1.Text       := Zone.TopCom[1];
     edZonCom2.Text       := Zone.TopCom[2];
     edZonCom3.Text       := Zone.TopCom[3];
End;

{Load zone file and show}
Procedure TfmCircleEd.LoadZones(Leer : String);
Begin
     ZoneFile.LoadFromFile(leer);
     Label76.Caption := extractfilename(leer);
     BuildZoneList;
     ZonZone := Zone.VNum;
     CurZon  := Zone.VNum;
     ShowZoneInfo;
     ShowCommandList;
     ZoneFile.Clear;
     pgMain.ActivePageIndex := 3;
End;

{insert a zone command at position pos, move other if neceary, if -1 or > max then add at back}
Procedure TfmCircleEd.InsertCommand(Pos : Integer);
Var
   Com     : String;
   IfFlag  : ShortInt;
   VNum    : Integer;
   Par3    : Integer;
   Par3cb  : Integer;
   Par4    : Integer;
   Par4cb  : Integer;
   Comment : String;
   i,
   num     : Integer;
Begin
     IfFlag  := seZonIF.Value;
     VNum    := seZonVNum.Value;
     Par3    := seZonPar3.Value;
     Par4    := seZonPar4.Value;
     Par3cb  := ExtractNumber(cbZonPar3.Items[cbZonPar3.itemindex]);
     Par4cb  := ExtractNumber(cbZonPar4.Items[cbZonPar4.itemindex]);
     Comment := edZonComment.Text;
     num := Length(Zone.Commands);
     SetLength(Zone.Commands,num+1);
     if (Pos > -1) and (Pos < Num) then
        for i := num downto pos+1 do
               Zone.Commands[i] := Zone.Commands[i-1] //Make space for insertee
     Else Pos := num;//at the back
     Case cbZonCommand.ItemIndex of
      0 : Begin
               Com := 'M';
               Zone.Commands[pos] := ZonComEquals(Com,IfFlag,VNum,Par3,Par4,Comment);
          End;
      1 : Begin
               Com := 'O';
               Zone.Commands[pos] := ZonComEquals(Com,IfFlag,VNum,Par3,Par4,Comment);
          End;
      2 : Begin
               Com := 'G';
               Zone.Commands[pos] := ZonComEquals(Com,IfFlag,VNum,Par3,-1,Comment);
          End;
      3 : Begin
               Com := 'E';
               Zone.Commands[pos] := ZonComEquals(Com,IfFlag,VNum,Par3,Par4cb,Comment);
          End;
      4 : Begin
               Com := 'P';
               Zone.Commands[pos] := ZonComEquals(Com,IfFlag,VNum,Par3,Par4,Comment);
          End;
      5 : Begin
               Com := 'D';
               Zone.Commands[pos] := ZonComEquals(Com,IfFlag,VNum,Par3cb,Par4cb,Comment);
          End;
      6 : Begin
               Com := 'R';
               Zone.Commands[pos] := ZonComEquals(Com,IfFlag,VNum,Par3,-1,Comment);
          End;
      7 : Begin
               Com := '*';
               Zone.Commands[pos] := ZonComEquals(Com,-1,-1,-1,-1,Comment);
          End;
     End;
End;

{change command at pos to gui}
Procedure TfmCircleEd.ChangeCommand(Pos : Integer);
Var
   Com     : String;
   IfFlag  : ShortInt;
   VNum    : Integer;
   Par3    : Integer;
   Par3cb  : Integer;
   Par4    : Integer;
   Par4cb  : Integer;
   Comment : String;

Begin
     IfFlag  := seZonIF.Value;
     VNum    := seZonVNum.Value;
     Par3    := seZonPar3.Value;
     Par4    := seZonPar4.Value;
     Par3cb  := ExtractNumber(cbZonPar3.Items[cbZonPar3.itemindex]);
     Par4cb  := ExtractNumber(cbZonPar4.Items[cbZonPar4.itemindex]);
     Comment := edZonComment.Text;

     Case cbZonCommand.ItemIndex of
      0 : Begin
               Com := 'M';
               Zone.Commands[pos] := ZonComEquals(Com,IfFlag,VNum,Par3,Par4,Comment);
          End;
      1 : Begin
               Com := 'O';
               Zone.Commands[pos] := ZonComEquals(Com,IfFlag,VNum,Par3,Par4,Comment);
          End;
      2 : Begin
               Com := 'G';
               Zone.Commands[pos] := ZonComEquals(Com,IfFlag,VNum,Par3,-1,Comment);
          End;
      3 : Begin
               Com := 'E';
               Zone.Commands[pos] := ZonComEquals(Com,IfFlag,VNum,Par3,Par4cb,Comment);
          End;
      4 : Begin
               Com := 'P';
               Zone.Commands[pos] := ZonComEquals(Com,IfFlag,VNum,Par3,Par4,Comment);
          End;
      5 : Begin
               Com := 'D';
               Zone.Commands[pos] := ZonComEquals(Com,IfFlag,VNum,Par3cb,Par4cb,Comment);
          End;
      6 : Begin
               Com := 'R';
               Zone.Commands[pos] := ZonComEquals(Com,IfFlag,VNum,Par3,-1,Comment);
          End;
      7 : Begin
               Com := '*';
               Zone.Commands[pos] := ZonComEquals(Com,-1,-1,-1,-1,Comment);
          End;
     End;
End;

{return space minus character length of num}
Function TS(num : integer) : String;
Const
     TabSize = 8;
Begin
     Result := StringOfChar(' ',TabSize-Length(IntToStr(num)));
End;

{show list of command in listbox}
Procedure TfmCircleEd.ShowCommandList;
Var
   i    : integer;
   Line : String;
Begin
     lbZone.Clear;

     for i := 0 to Length(Zone.Commands)-1 do
     Begin
          With Zone.Commands[i] do
          Begin

               Line := Command + TS(0);
               Line := Line + IntToStr(IfPar) + TS(IfPar);
               Line := Line + IntToStr(VNum)   + TS(VNum);
               Line := Line + IntToStr(Par3)   + TS(Par3);
               If (Command <> 'R') and (Command <> 'G') then
                  Line := Line + IntToStr(Par4)+ TS(Par4);
               If Command <> '*' then
                  Line := Line + Comment
               Else
                  Line := '* '+Comment;
               lbZone.Items.Add(Line);
          End;
     End;
End;
{
//to do show in treeview format
Procedure TfmCircleEd.ShowCommandList;
Var
   NodePos,
   i       : integer;
   Line    : String;
   ParNode,
   TheNode : TTreeNode;

Begin
     tvZone.Items.Clear;

     for i := 0 to Length(Zone.Commands)-1 do
     Begin
          With Zone.Commands[i] do
          Begin

               Line := Command + TS(0);
               Line := Line + IntToStr(IfPar) + TS(IfPar);
               Line := Line + IntToStr(VNum)   + TS(VNum);
               Line := Line + IntToStr(Par3)   + TS(Par3);
               If (Command <> 'R') and (Command <> 'G') then
                  Line := Line + IntToStr(Par4)+ TS(Par4);
               If Command <> '*' then
                  Line := Line + Comment
               Else
                  Line := '* '+Comment;
               if (Command = 'M') or
                  (Command = 'O') or
                  (Command = 'D') or
                  (Command = 'R') or
                  (Command = 'P') or
                  (Command = '*') then
               Begin
                     tvZone.Items.AddChild(ZontvRoot,Line);
               End
               Else Begin
                    if (Command = 'G') or
                       (Command = 'E') then
                    Begin
                         NodePos := ZonPrevCom('M',i);
                         ParNode := tvZone.Items[NodePos];
                         tvZone.Items.AddChild(ParNode,Line);
                    End;
               End;

               //lbZone.Items.Add(Line);
          End;
     End;
End;
 }

{change command in listbox at index compos to zone.command[compos]}
Procedure TfmCircleEd.ZonComGUI( ComPos : Integer);
Var
   num,code,
   i : integer;
   p : string;
Begin
     With Zone.Commands[ComPos] do
     Begin
          for i := 0 to cbZonCommand.Items.Count-1 do
          Begin
               if Copy(cbZonCommand.Items[i],1,1) = Command then
               Begin
                    cbZonCommand.ItemIndex := i;
                    break;
               End;
          End;
          seZonIF.Value     := IfPar;
          seZonVNum.Value   := VNum;
          If (Command <> 'E') and (Command <> 'D') then
          Begin
               seZonPar3.Value   := Par3;
               seZonPar4.Value   := Par4;
          End Else
          Begin
               for i := 0 to cbZonPar4.Items.Count-1 do
               Begin
                    GetParams(cbZonPar4.Items[i],[@p]);
                    Val(p,num,code);
                    if code = 0 then
                       if num = par4 then
                       Begin
                            cbZonPar4.ItemIndex := i;
                            break;
                       End;
               End;
               If (Command = 'D') then
                  for i := 0 to cbZonPar3.Items.Count-1 do
                  Begin
                       GetParams(cbZonPar3.Items[i],[@p]);
                       Val(p,num,code);
                       if code = 0 then
                          if num = par3 then
                          Begin
                               cbZonPar3.ItemIndex := i;
                               break;
                          End;
                  End Else seZonPar3.Value   := Par3;
          End;
          edZonComment.Text := Comment;
     End;
End;

{read zone file and parse to memory}
Procedure TfmCircleEd.BuildZoneList;
Var
   Num,
   Num1,
   Num2,
   Num3,
   Code,
   Code1,
   Code2,
   Code3,
   NrofCom,
   i,pars,
   Lmode   : Integer;
   Des     : Double;
   p,p1,p2,p3,p4,
   Line    : String;
   StKar   : Char;
Begin

     i       := 0;
     LMode   := 0; //Not started
     SetLength(Zone.Commands,0);

     Repeat
           Line := ZoneFile.Strings[i];
           Case LMode of
           -1 : begin end; 
            0 : if (StartWith('#',Line)) then        //Beginning  Zone Vnum
                Begin
                     GetParams(Line,[@p1]);
                     delete(p1,1,1);
                     Val(p1,Num,Code);
                     if Code = 0 then
                     Begin
                          Zone.VNum := Num;
                          Lmode := 2; // Zone Name;
                          Zone.TopCom[1] := ExtractComment(Line);
                          Zone.ZoneName  := '';
                     End;
                End;
            2 : Begin  // Zone Name
                     Num := Pos('~',Line);
                     if Num = 0 then Zone.ZoneName := Zone.ZoneName + Line
                     Else Begin
                          p1 := copy(Line,1,Num-1);
                          Zone.ZoneName := Zone.ZoneName + p1;
                          Zone.TopCom[2] := ExtractComment(Line);
                          Lmode := 3; //Next <bottom room number> <top room number> <lifespan> <reset mode>
                     End;
                End;
            3 : if (Line <> '') then   //<bottom room number> <top room number> <lifespan> <reset mode>
                Begin
                     Zone.TopCom[3] := ExtractComment(Line);
                     pars := GetParams(Line,[@p,@p1,@p2,@p3]);
                     Val(p,Num,Code);
                     Val(p1,Num1,Code1);
                     Val(p2,Num2,Code2);
                     Val(p3,Num3,Code3);

                     if pars >= 4 then   //if zone has a bottom room
                     Begin
                          if (Code  = 0) and
                             (Code1 = 0) and
                             (Code2 = 0) and
                             (Code3 = 0) then
                          Begin
                               Zone.BottomRoom := num;
                               Zone.TopRoom    := num1;
                               Zone.LifeSpan   := num2;
                               Zone.ResetMode  := num3;
                               LMode := 4; //Commands
                          End;
                     End Else
                     if pars >= 3 then   //if zone has no a bottom room (this zone file is realy corrupt but many are still this way, including the example in the docs)
                     Begin
                          if (Code  = 0) and
                             (Code1 = 0) and
                             (Code2 = 0) then
                          Begin
                               Zone.BottomRoom := Zone.VNum*100;
                               Zone.TopRoom    := num;
                               Zone.LifeSpan   := num1;
                               Zone.ResetMode  := num2;
                               LMode := 4; //Commands
                          End;
                     End
                End;
            4 : if Line <> '' then
                Begin
                     if Startwith('S',Line) or Startwith('$',Line)then
                     Begin
                          LMode := -1; //End of file
                     End Else
                     Begin
                          pars := GetParams(Line,[@p,@p1,@p2,@p3,@p4]);
                          if (pars >= 4) or (p = '*') then
                          Begin
                               StKar := p[1];
                               Val(p1,Num1,Code1);
                               Val(p2,Num2,Code2);
                               Val(p3,Num3,Code3);
                               Val(p4,Num,Code);
                               NrofCom := Length(Zone.Commands);
                               if (StKar = 'M') or
                                  (StKar = 'O') or
                                  (StKar = 'E') or
                                  (StKar = 'P') or
                                  (StKar = 'D') then
                               Begin
                                    if (Code1 = 0) and
                                       (Code2 = 0) and
                                       (Code3 = 0) and
                                       (Code  = 0) then
                                    Begin
                                         SetLength(Zone.Commands,NrofCom+1);
                                         Zone.Commands[NrofCom].Command := StKar;
                                         Zone.Commands[NrofCom].IfPar   := Num1;
                                         Zone.Commands[NrofCom].Vnum    := Num2;
                                         Zone.Commands[NrofCom].Par3    := Num3;
                                         Zone.Commands[NrofCom].Par4    := Num;
                                         Zone.Commands[NrofCom].Comment := ExtractComComment(line,5);
                                    End;
                               End Else
                               if (StKar = 'G') or
                                  (StKar = 'T') then
                               Begin
                                    if (Code1 = 0) and
                                       (Code2 = 0) and
                                       (Code3 = 0) then
                                    Begin
                                         SetLength(Zone.Commands,NrofCom+1);
                                         Zone.Commands[NrofCom].Command := StKar;
                                         Zone.Commands[NrofCom].IfPar   := Num1;
                                         Zone.Commands[NrofCom].Vnum    := Num2;
                                         Zone.Commands[NrofCom].Par3    := Num3;
                                         Zone.Commands[NrofCom].Par4    := 0;
                                         Zone.Commands[NrofCom].Comment := ExtractComComment(line,4);
                                    End;
                               End Else
                               If (StKar = '*') then
                               Begin
                                    SetLength(Zone.Commands,NrofCom+1);
                                    Zone.Commands[NrofCom].Command := StKar;
                                    num := pos('*',Line);
                                    Zone.Commands[NrofCom].Comment := Copy(line,num+1,Length(Line)-num-1)
                               End;

                          End;
                     End;
                End;
            End;
            inc(i);     
     Until (i = ZoneFile.Count) or (Lmode = -1); 
End;

{=====END ZONES======}


{-----------------}
{SHOP PROCEDURES}
{-----------------}
{load shop and show}
Procedure TfmCircleEd.LoadShops(Leer : String);
Begin
     //ShowMessage('Loading Shops');
     pgMain.ActivePageIndex := 4;
     ShpFile.LoadFromFile(leer);
     Label51.Caption := extractfilename(leer);
     BuildShpList;
     ShowShpList;
     ShpZone := (shops[0].Vnum div 100);
     ShpFile.Clear;
End;
{Show list of shops in listbox}
Procedure TfmCircleEd.ShowShpList;
Var
   i : Integer;
Begin
     lbShp.Clear;
     for i := 0 to Length(Shops)-1 do
     Begin
          lbShp.Items.Add(IntToStr(Shops[i].VNum));
     End;
     if lbShp.Items.Count > 0 then
     Begin
          lbShp.Selected[0] := true;
          ShpToGUI(0);
     End;
End;

{put shop number num in gui}
Procedure TfmCircleEd.ShpToGUI(Num : integer);
Var
   i,
   ind : Integer;
Begin
     CurShp := Num;
     With Shops[Num] do
     Begin
          edShpVNum.Text        := IntToStr(VNum);   //VNUM
          edShpProfitBuy.text   := FloatToStr((1-ProfitBuy)*100);
          edShpProfitSell.Text  := FloatToStr((ProfitSell-1)*100);
          seShpKeeperVnum.Value := ShopKeeperVnum;
          seShpOpen1.Value      := TimeOpen1;
          seShpClose1.Value     := TimeClose1;
          seShpOpen2.Value      := TimeOpen2;
          seShpClose2.Value     := TimeClose2;
          edShpMsg1.Text        := Messages[1];
          edShpMsg2.Text        := Messages[2];
          edShpMsg3.Text        := Messages[3];
          edShpMsg4.Text        := Messages[4];
          edShpMsg5.Text        := Messages[5];
          edShpMsg6.Text        := Messages[6];
          edShpMsg7.Text        := Messages[7];

          ind := FindNumber(chlbShpTemperFlags,Temper);
          RadioCheck(ind,chlbShpTemperFlags);

          for i := 0 to chlbShpBV.Items.Count-1 do chlbShpBV.Checked[i] := false;
          for i := 1 to Length(ShopBV) do
          Begin
               ind := FindString(chlbShpBV,ShopBV[i]);
               chlbShpBV.Checked[ind] := true;
          End;

          for i := 0 to chlbShpWithWhoBV.Items.Count-1 do chlbShpWithWhoBV.Checked[i] := false;
          for i := 1 to Length(WithWhoBV) do
          Begin
               ind := FindString(chlbShpWithWhoBV,WithWhoBV[i]);
               chlbShpWithWhoBV.Checked[ind] := true;
          End;

          if Length(Items) > sgShpItems.RowCount then
             sgShpItems.RowCount := sgShpItems.RowCount + 10; //
          for i := 0 to sgShpItems.RowCount-1 do
          Begin
               sgShpItems.Cells[0,i+1] := '';
          End;
          for i := 0 to Length(Items)-1 do
          Begin
               sgShpItems.Cells[0,i+1] := IntToStr(Items[i]);
          End;

          if Length(ShopsVNum) > sgShpRooms.RowCount then
             sgShpRooms.RowCount := sgShpRooms.RowCount + 10; //
          for i := 0 to sgShpRooms.RowCount-1 do
          Begin
               sgShpRooms.Cells[0,i+1] := '';
          End;
          for i := 0 to Length(ShopsVNum)-1 do
          Begin
               sgShpRooms.Cells[0,i+1] := IntToStr(ShopsVNum[i]);
          End;

          lbBuyTypes.Clear;
          SetLength(ShpBuy,Length(BuyList));
          for i:= 0 to Length(BuyList)-1 do
          Begin
               lbBuyTypes.Items.Add(BuyList[i].BuyType);
               ShpBuy[i].BuyType := BuyList[i].BuyType;
               ShpBuy[i].BuyList := BuyList[i].BuyList;
          End;
          
     End;
End;
{parse shopfile into mem}
Function TfmCircleEd.BuildShpList : Integer;
Var
   Num,
   Num1,
   Code,
   Code1,
   NrofShp,
   i,
   Lmode   : Integer;
   Des     : Double;
   p,p1,p2,
   Line    : String;
Begin
//     Result  := 0;
     i       := 0;
     NrofShp := 0;
     LMode   := 0; //Not in Shop
     SetLength(Shops,0);

     //lbWld.Items.Clear;
     Repeat
           Line := ShpFile.Strings[i];
           Case LMode of
           -1 : begin end; //End of File It should not reach this
            0 : if (StartWith('#',Line)) then        // Not in Object
                Begin
                     GetParams(Line,[@p1]);
                     delete(p1,1,1);
                     Val(p1,Num,Code);
                     if Code = 0 then
                     Begin
                          inc(NrofShp);
                          SetLength(Shops,NrofShp);
                          Shops[NrofShp-1].Vnum := Num;
                          Shops[NrofShp-1].ShopFormat := '2.20';
                          Lmode := 30; // In shop 2.2;
                     End;
                End Else
                if Line = 'CircleMUD v3.0 Shop File~' then
                Begin
                     Lmode := 1; //Shop 3.0
                End;
            1 : if (StartWith('#',Line)) then        // Not in Shop but shop 3.0
                Begin
                     GetParams(Line,[@p1]);
                     delete(p1,1,1);
                     delete(p1,pos('~',p1),1);
                     Val(p1,Num,Code);
                     if Code = 0 then
                     Begin
                          inc(NrofShp);
                          SetLength(Shops,NrofShp);
                          Shops[NrofShp-1].Vnum := Num;
                          Shops[NrofShp-1].ShopFormat := '3.00';
                          Lmode := 2; // item List;
                     End;
                End;
            2 : Begin  //item List
                     GetParams(Line,[@p1]);
                     Val(p1,Num,Code);
                     if Code = 0 then
                     Begin
                          if Num > -1 then
                          Begin
                               num1 := Length(Shops[NrofShp-1].Items);
                               SetLength(Shops[NrofShp-1].Items,num1+1);
                               Shops[NrofShp-1].Items[num1] := Num;
                               //Lmode := 3; //Next Long Description
                          End Else
                              if Num = -1 then Lmode := 3; //profit selling
                     End;
                End;
            3 : if (Line <> '') then   //profit selling
                Begin
                     if GetParams(Line,[@p1]) >= 1 then
                     begin
                          Val(p1,Des,Code1);
                          if Code = 0 then
                          Begin
                               Shops[NrofShp-1].ProfitSell := strtofloat(p1);
                               Lmode := 4; //profit buying
                          End;
                     End;
                End;
            4 : if (Line <> '') then   //profit buying
                Begin
                     if GetParams(Line,[@p1]) >= 1 then
                     begin
                          Val(p1,Des,Code1);
                          if Code = 0 then
                          Begin

                               Shops[NrofShp-1].ProfitBuy :=des;
                               Lmode := 5; //Buy List
                          End;
                     End;
                End;
            5 : if (Line <> '') then   //Buy List
                Begin
                     p2 := '';
                     if GetParams(Line,[@p1,@p2]) >= 1 then   //with ascii Extra b.v. and Wear b.v could be empty
                     Begin
                          if p1 <> '-1' then
                          Begin
                               num := Length(Shops[NrofShp-1].BuyList);
                               SetLength(Shops[NrofShp-1].BuyList,num+1);
                               Val(p1,Num1,Code1);
                               If Code1 = 0 then //if buytype is a number
                               Begin
                                    p1 := StringConv('Object_TypeFlag',num1);
                               End;
                               Shops[NrofShp-1].BuyList[num].BuyType := p1;
                               Shops[NrofShp-1].BuyList[num].BuyList := p2;
                          End else LMode := 6; //msg 1
                     End;
                End;
            6 : if (Line <> '') then //msg 1
                Begin
                     if GetParams(Line,[@p]) >= 1 then
                     Begin
                          if p = '%s' then
                          Begin
                               Delete(Line,1,3);
                               delete(Line,pos('~',Line),1);
                               Shops[NrofShp-1].Messages[1] := Line;
                               LMode := 7; //msg 2
                          End;
                     End;
                End;
            7 : if (Line <> '') then //msg 2
                Begin
                     if GetParams(Line,[@p]) >= 1 then
                     Begin
                          if p = '%s' then
                          Begin
                               Delete(Line,1,3);
                               delete(Line,pos('~',Line),1);
                               Shops[NrofShp-1].Messages[2] := Line;
                               LMode := 8; //msg 3
                          End;
                     End;
                End;
            8 : if (Line <> '') then //msg 3
                Begin
                     if GetParams(Line,[@p]) >= 1 then
                     Begin
                          if p = '%s' then
                          Begin
                               Delete(Line,1,3);
                               delete(Line,pos('~',Line),1);
                               Shops[NrofShp-1].Messages[3] := Line;
                               LMode := 9; //msg 4
                          End;
                     End;
                End;
            9 : if (Line <> '') then //msg 4
                Begin
                     if GetParams(Line,[@p]) >= 1 then
                     Begin
                          if p = '%s' then
                          Begin
                               Delete(Line,1,3);
                               delete(Line,pos('~',Line),1);
                               Shops[NrofShp-1].Messages[4] := Line;
                               LMode := 10; //msg 5
                          End;
                     End;
                End;
           10 : if (Line <> '') then //msg 5
                Begin
                     if GetParams(Line,[@p]) >= 1 then
                     Begin
                          if p = '%s' then
                          Begin
                               Delete(Line,1,3);
                               delete(Line,pos('~',Line),1);
                               Shops[NrofShp-1].Messages[5] := Line;
                               LMode := 11; //msg 6
                          End;
                     End;
                End;
           11 : if (Line <> '') then //msg 6
                Begin
                     if GetParams(Line,[@p]) >= 1 then
                     Begin
                          if p = '%s' then
                          Begin
                               Delete(Line,1,3);
                               delete(Line,pos('~',Line),1);
                               Shops[NrofShp-1].Messages[6] := Line;
                               LMode := 12; //msg 7
                          End;
                     End;
                End;
           12 : if (Line <> '') then //msg 7
                Begin
                     if GetParams(Line,[@p]) >= 1 then
                     Begin
                          if p = '%s' then
                          Begin
                               Delete(Line,1,3);
                               delete(Line,pos('~',Line),1);
                               Shops[NrofShp-1].Messages[7] := Line;
                               LMode := 13; //Temper
                          End;
                     End;
                End;
           13 : if (Line <> '') then   //Temper
                Begin
                     if GetParams(Line,[@p1]) >= 1 then
                     begin
                          Val(p1,num,Code1);
                          if Code = 0 then
                          Begin
                               Shops[NrofShp-1].Temper := num;
                               Lmode := 14; //Shop Bitvector
                          End;
                     End;
                End;
           14 : if (Line <> '') then   //Shop Bitvector
                Begin
                     if GetParams(Line,[@p1]) >= 1 then
                     begin
                          Val(p1,num1,Code1);
                          if Code = 0 then p1 := ConvertNumS('Shop_BV',num1);
                          Shops[NrofShp-1].ShopBV := p1;
                          Lmode := 15; //Shop keeper Vnum
                     End;
                End;
           15 : if (Line <> '') then   //Shop keeper Vnum
                Begin
                     if GetParams(Line,[@p1]) >= 1 then
                     begin
                          Val(p1,num1,Code1);
                          if Code = 0 then
                          Begin
                               Shops[NrofShp-1].ShopKeeperVNum := num1;
                               Lmode := 16; //with who Bitvector
                          End;
                     End;
                End;
           16 : if (Line <> '') then   //with who Bitvector
                Begin
                     if GetParams(Line,[@p1]) >= 1 then
                     begin
                          Val(p1,num1,Code1);
                          if Code = 0 then p1 := ConvertNumS('[Shop_WithwWhoBV',num1);
                          Shops[NrofShp-1].WithWhoBV := p1;
                          Lmode := 17; //shop vnum list
                     End;
                End;
           17 : if (Line <> '') then
                Begin  //shop vnum list
                     GetParams(Line,[@p1]);
                     Val(p1,Num,Code);
                     if Code = 0 then
                     Begin
                          if Num > -1 then
                          Begin
                               num1 := Length(Shops[NrofShp-1].ShopsVNum);
                               SetLength(Shops[NrofShp-1].ShopsVNum,num1+1);
                               Shops[NrofShp-1].ShopsVNum[num1] := Num;
                          End Else
                              if Num = -1 then Lmode := 18; //Time Open 1
                     End;
                End;
           18 : if (Line <> '') then   //Time Open 1
                Begin
                     if GetParams(Line,[@p1]) >= 1 then
                     begin
                          Val(p1,num1,Code1);
                          if Code = 0 then
                          Begin
                               Shops[NrofShp-1].TimeOpen1 := num1;
                               Lmode := 19; //Time Close 1
                          End;
                     End;
                End;
           19 : if (Line <> '') then   //Time Close 1
                Begin
                     if GetParams(Line,[@p1]) >= 1 then
                     begin
                          Val(p1,num1,Code1);
                          if Code = 0 then
                          Begin
                               Shops[NrofShp-1].TimeClose1 := num1;
                               Lmode := 20; //Time Open 2
                          End;
                     End;
                End;
           20 : if (Line <> '') then   //Time Open 2
                Begin
                     if GetParams(Line,[@p1]) >= 1 then
                     begin
                          Val(p1,num1,Code1);
                          if Code = 0 then
                          Begin
                               Shops[NrofShp-1].TimeOpen2 := num1;
                               Lmode := 21; //Time Close 2
                          End;
                     End;
                End;
           21 : if (Line <> '') then   //Time Close 1
                Begin
                     if GetParams(Line,[@p1]) >= 1 then
                     begin
                          Val(p1,num1,Code1);
                          if Code = 0 then
                          Begin
                               Shops[NrofShp-1].TimeClose2 := num1;
                               Lmode := 1; //next shop 3
                          End;
                     End;
                End;
            30 : Begin  ShowMessage('todo shopformat 2.20') end;

            Else ShowMessage('no mode??');
           End;


           inc(i);
     Until (i = ShpFile.Count) or (Lmode = -1); //i should be pass ObjFile.Count-1
     Result := i-1;
     //Check for duplicates

End;

{return index of shop with vnum: vnum}
Function TfmCircleEd.ShopPos(Vnum : Integer): Integer;
Var
   i  : Integer;
Begin
     Result := -1;  //If not found return -1
     for i := 0 to Length(Shops)-1 do
     Begin
          if Shops[i].Vnum = VNum then
          Begin
               Result := i;
               Exit;
          End;
     End;
End;

{Create new shop and assign default values}
Function TfmCircleEd.NewShp(VNum : Integer) : Integer ;
Begin
     Result := Length(Shops);
     SetLength(Shops,Result+1);
     Shops[Result].Vnum := VNum;
     Shops[Result].ProfitSell := 1.1;
     Shops[Result].ProfitBuy  := 0.9;
     Shops[Result].TimeClose1 := 28;
     Shops[Result].ShopFormat := '3.00';
     //Example
     Shops[Result].Messages[1] := 'Sorry, I haven''t got exactly that item.';
     Shops[Result].Messages[2] := 'You don''t seem to have that.';
     Shops[Result].Messages[3] := 'I don''t buy such items.';
     Shops[Result].Messages[4] := 'That is too expensive for me!';
     Shops[Result].Messages[5] := 'You can''t afford it!';
     Shops[Result].Messages[6] := 'That''ll be %d coins, please.';
     Shops[Result].Messages[7] := 'You''ll get %d coins for it!';
End;

{equals two shops}
Function TfmCircleEd.ShpEquals(OldShp : TShp) : TShp;
Var
   j : Integer;
Begin
     With Result do
     Begin
          Vnum           := OldShp.Vnum;
          ProfitSell     := OldShp.ProfitSell;
          ProfitBuy      := OldShp.ProfitBuy;
          Temper         := OldShp.Temper;
          ShopBV         := OldShp.ShopBV;
          ShopKeeperVNum := OldShp.ShopKeeperVNum;
          WithWhoBV      := OldShp.WithWhoBV;
          TimeOpen1      := OldShp.TimeOpen1;
          TimeClose1     := OldShp.TimeClose1;
          TimeOpen2      := OldShp.TimeOpen2;
          TimeClose2     := OldShp.TimeClose2;
          ShopFormat     := OldShp.ShopFormat;


          SetLength(Items,Length(OldShp.Items));
          for j := 0 to Length(OldShp.Items) -1 do
              Items[j]  := OldShp.Items[j];

          for j := 1 to 7 do
              Messages[j]  := OldShp.Messages[j];

          SetLength(ShopsVNum,Length(OldShp.ShopsVNum));
          for j := 0 to Length(OldShp.ShopsVNum) -1 do
              ShopsVNum[j]  := OldShp.ShopsVNum[j];

          SetLength(BuyList,Length(OldShp.BuyList));
          for j := 0 to Length(OldShp.BuyList) -1 do
          Begin
               BuyList[j].BuyType := OldShp.BuyList[j].BuyType;
               BuyList[j].BuyList := OldShp.BuyList[j].BuyList;
          End;

     End;
End;

{sort shop by vnum}
Procedure TfmCircleEd.ShpSort;
Var
   i,j : Integer;
   TempShp : TShp;
Begin
     for i := 0 to Length(Shops)-1 do
     Begin
          for j := i+1 to Length(Shops)-1 do
          Begin
               if Shops[i].Vnum > Shops[j].Vnum then
               Begin
                    TempShp  := ShpEquals(Shops[i]);
                    Shops[i] := ShpEquals(Shops[j]);
                    Shops[j] := ShpEquals(TempShp);
               End;
          End;
     End;
End;

{returns stringlist of shop in circle format}
Function TfmCircleEd.RenderShp(Shp : TShp) : TStringList;
Var
   i : Integer;
Begin
     Result := TStringList.Create;
     With Shp do
     Begin
          //Format 3.00
          Result.Add('#'+IntToStr(VNum)+'~');
          for i := 0 to Length(Items)-1 do
              Result.Add(IntToStr(Items[i]));
          Result.Add('-1');
         // Result.Add(FloatToStrF(ProfitSell,ffGeneral,100,2));
         // Result.Add(FloatToStrF(ProfitBuy,ffGeneral,100,2));
          Result.Add(FloatToStr(ProfitSell));
          Result.Add(FloatToStr(ProfitBuy));

          for i := 0 to Length(BuyList)-1 do
              Result.Add(BuyList[i].BuyType+' '+BuyList[i].BuyList);
          Result.Add('-1');
          for i := 1 to 7 do
              Result.Add('%s '+Messages[i]+'~');
          Result.Add(IntToStr(Temper));
          if ShopBV = '' then ShopBV := '0';
          Result.Add(ShopBV);
          Result.Add(IntToStr(ShopKeeperVNum));
          if WithWhoBV = '' then WithWhoBV := '0';
          Result.Add(WithWhoBV);
          for i := 0 to Length(ShopsVNum)-1 do
              Result.Add(IntToStr(ShopsVNum[i]));
          Result.Add('-1');
          Result.Add(IntToStr(TimeOpen1));
          Result.Add(IntToStr(TimeClose1));
          Result.Add(IntToStr(TimeOpen2));
          Result.Add(IntToStr(TimeClose2));
     End;
End;

{return shop gui }
Function TfmCircleEd.ShpGUItoMem : TShp;
var
   i,cnt : integer;
   Num,Code : integer;
Begin
     With Result do
     Begin
          Vnum           := StrToInt(edShpVnum.Text);
          ProfitSell     := 1+(StrToFloat(edShpProfitSell.Text)/100);
          ProfitBuy      := 1-(StrToFloat(edShpProfitBuy.Text)/100);
          Temper         := GetFlagNumber(chlbShpTemperFlags);
          ShopBV         := ParseCheckBox(chlbShpBV);
          ShopKeeperVNum := seShpKeeperVnum.Value;
          WithWhoBV      := ParseCheckBox(chlbShpWithWhoBV);
          TimeOpen1      := seShpOpen1.Value;
          TimeClose1     := seShpClose1.Value;
          TimeOpen2      := seShpOpen2.Value;
          TimeClose2     := seShpClose2.Value;

          Messages[1]    := edShpMsg1.Text;
          Messages[2]    := edShpMsg2.Text;
          Messages[3]    := edShpMsg3.Text;
          Messages[4]    := edShpMsg4.Text;
          Messages[5]    := edShpMsg5.Text;
          Messages[6]    := edShpMsg6.Text;
          Messages[7]    := edShpMsg7.Text;

          SetLength(Items,0);
          cnt := 0;
          for i := 1 to sgShpItems.RowCount-1 do
          Begin
               Val(sgShpItems.Cells[0,i],num,code);
               if Code = 0 then
               Begin
                    inc(cnt);
                    SetLength(Items,cnt);
                    Items[cnt-1] := num;
               End;
          End;

          SetLength(ShopsVNum,0);
          cnt := 0;
          for i := 1 to sgShpRooms.RowCount-1 do
          Begin
               Val(sgShpRooms.Cells[0,i],num,code);
               if Code = 0 then
               Begin
                    inc(cnt);
                    SetLength(ShopsVNum,cnt);
                    ShopsVNum[cnt-1] := num;
               End;
          End;

          SetLength(BuyList,Length(ShpBuy));
          for i := 0 to Length(ShpBuy)-1 do
          Begin
               BuyList[i].BuyType := ShpBuy[i].BuyType;
               BuyList[i].BuyList := ShpBuy[i].BuyList;
          End

     End;
End;


{=====END SHOPS======}




{-------------}
{GUI FUNCTIONS}
{-------------}

{--Object GUI--}
{Menu Option Click}
procedure TfmCircleEd.Options1Click(Sender: TObject);
begin
     if fmOptions.ShowModal = mrOK then
     Begin
          Options.LoadFromFile('options.dat');
          if fmOptions.VectorChanged then
          Begin
               ShowVectors;
          End;
     End;
end;

{Menu Exit Click}
procedure TfmCircleEd.Exit1Click(Sender: TObject);
begin
     fmCircleEd.Close;
end;

{Form Show}
procedure TfmCircleEd.FormShow(Sender: TObject);
begin
     Options.LoadFromFile('options.dat');
     WindowState := wsMaximized;
end;

{Form Create}
procedure TfmCircleEd.FormCreate(Sender: TObject);

begin
     Options  := TStringList.Create;
     ObjFile  := TStringList.Create;
     MobFile  := TStringList.Create;
     WldFile  := TStringList.Create;
     ShpFile  := TStringList.Create;
     ZoneFile := TStringList.Create;
     LoadVectors;
     ShowVectors;

     sgShpItems.Cells[0,0]        := 'VNum';
     sgShpRooms.Cells[0,0]        := 'VNum';
     if FileExists('options.dat') then
     Begin
          Options.LoadFromFile('options.dat');
     End;

end;

{Menu,Toolbar Load Click}
procedure TfmCircleEd.Load1Click(Sender: TObject);
begin
     OpenDialog1.InitialDir := Options.Strings[0];
     if OpenDialog1.Execute then
     Begin
          Case OpenDialog1.FilterIndex of
               1 : LoadObjects(OpenDialog1.FileName);  //Object
               2 : LoadMobiles(OpenDialog1.FileName);  //Mobile
               3 : LoadWorlds(OpenDialog1.FileName);   //World
               4 : LoadZones(OpenDialog1.FileName);    //Zone
               5 : LoadShops(OpenDialog1.FileName);    //Shop
          else exit;
          End;
     End;
end;

{Edit Object VNUM Key Press}
procedure TfmCircleEd.edObjVNumKeyPress(Sender: TObject; var Key: Char);
begin
     NumOnly(key,false);
end;

{Edit Value Key Press}
procedure TfmCircleEd.edObjVal0KeyPress(Sender: TObject; var Key: Char);
begin
     NumOnlyE(Key,false,true);
end;

{Object Value Help Click}
{Procedure shows help on the selected Flag}
procedure TfmCircleEd.btObjValHelpClick(Sender: TObject);
begin
//     if chlbtypeFlags.ItemIndex < 0 then exit;
     fmObjValHelp.WType := GetFlagNumber(chlbTypeFlags);
     fmObjValHelp.Show;
end;

{Button Object Value Help Right Click}
{Show Form with help ons Spells}
procedure TfmCircleEd.btObjValHelpContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
     fmSpellList.Show;
end;


procedure TfmCircleEd.rgObjTypeFlagClick(Sender: TObject);
begin
     fmObjValHelp.WType := GetFlagNumber(chlbTypeFlags);
end;

{Checklistbox Click Check}
{Change checkbox into a "radio box"}
procedure TfmCircleEd.chlbTypeFlagsClickCheck(Sender: TObject);
Var
   i,
   II : Integer;
begin
     //Change the checkbox listbox into a radio listbox
     II := chlbtypeFlags.ItemIndex;
     for i := 0 to chlbtypeFlags.Items.Count-1 do
         chlbtypeFlags.Checked[i] := false;
     chlbTypeFlags.Checked[II] := true;
     chlbTypeFlags.ItemIndex := II;

     fmObjValHelp.WType := GetFlagNumber(chlbTypeFlags); //For the value help update
end;

{String Grid Object Affect Click Key Press}
procedure TfmCircleEd.ssgObjAffectFieldsKeyPress(Sender: TObject;
  var Key: Char);
begin
     NumOnlyE(Key,false,true); //only number, and "-" allowed
end;

{ListBox Object Click}
{Procedure to select different Objects}
procedure TfmCircleEd.lbObjClick(Sender: TObject);
Var
   Num : Integer;
begin
     if lbObj.Items.Count < 1 then exit;
    Num := ObjectPos(StrToInt(lbObj.Items[lbObj.ItemIndex]) );
    if Num >= 0 then
       ObjToGUI(Num);
end;



{Button Object VNUM Click}
{Procedure to change an objects vnum}
procedure TfmCircleEd.btObjVNumClick(Sender: TObject);
Var
   min,
   CVNum,
   NewVNum : Integer;
begin
     if CurObj = -1 then exit; //Change to New Later
     CVnum := Objects[CurObj].Vnum;
     min := (CVnum div 100)*100;
     Repeat
           NewVNum := InputBox('Enter new VNum','New VNum:',CVnum,min,min+99,1);
     Until (ObjectPos(NewVnum) = -1) or (NewVNum = CVnum);   //Check if new VNUM Exits
     lbObj.Items[ObjectPos(CVNum)] := IntToStr(NewVNum);
     Objects[CurObj].Vnum := NewVNum;
     //ObjToGUI(ObjectPos(NewVNum));
     edObjVNum.Text := IntToStr(NewVNum);
     lbObj.Sort
end;

{Edit Object Find Change}
{Procedure finds an object which starts with edit}
procedure TfmCircleEd.edObjFindChange(Sender: TObject);
Var
   i : Integer;
begin
     if edObjFind.Text = '' then Exit;
     if lbObj.Items.Count < 1 then Exit;
     for i := 0 to lbObj.Items.Count do
     Begin
          if StartWith(edObjFind.Text,lbObj.Items[i]) then
          Begin
               lbObj.Selected[i] := true;
               ObjToGUI(i);
               Exit;
          End;
     End;
end;

{Button Object New Click}
procedure TfmCircleEd.btObjNewClick(Sender: TObject);
Var
   i,NewVNum,
   NrofObj   : Integer;
begin
     if ObjZone = -1 then exit; //Do new Object file
     for i := 0 to 99 do
     Begin
          if (ObjectPos((ObjZone*100)+ i) = -1) then
          Begin
               NewVNum := (ObjZone*100)+ i;
               NrofObj := NewObj(NewVNum);
               lbObj.Items.Add(IntToStr(NewVNum));
               lbObj.Sort;
               ObjToGUI(NrofObj);

               lbObj.Selected[ObjectPos((ObjZone*100)+ i)] := true;
               Exit;
          End;
     End;
end;

{Menu,Toolbar Save Object File Click}
procedure TfmCircleEd.SaveObjectFile1Click(Sender: TObject);
Var
   i  : integer;
begin
     if (CurObj = -1) or (ObjZone = -1) then exit;
     SaveDialog1.InitialDir  := Options.Strings[0];
     SaveDialog1.FileName    := IntToStr(ObjZone)+'.obj';
     SaveDialog1.FilterIndex := 1;
     if SaveDialog1.Execute then
     Begin
          ObjSort;
          ObjFile.Clear;
          for i := 0 to Length(Objects)-1 do
          Begin
               ObjFile.AddStrings(RenderObj(Objects[i]) );
          End;
          ObjFile.Add('$');
          ObjFile.SaveToFile(SaveDialog1.FileName);
     End;
end;

{Button Accept Click}
{Press Accept to move GUI to Mem}
procedure TfmCircleEd.btAcceptClick(Sender: TObject);
begin
     if (ObjZone = -1) or (CurObj = -1) or (lbObj.Rows = 0) then exit;
     Objects[CurObj] := ObjGUItoMem;
end;

{Menu/Toolbar New Object File Click}
{To Create new object file
 This doesn't create the file just get a zone number}
procedure TfmCircleEd.NewObjectFile1Click(Sender: TObject);
Var
   FN : Integer;
begin
     FN := InputBox('Object File Name','Enter Filename(Number)',0,0,999,1);
     if FN <> 0 then
     Begin
          ObjZone := FN;
          Label1.Caption := IntToStr(FN)+'.obj';
          SetLength(Objects,0);
          ShowObjList;
     End;
end;

{Button Delete Object}
procedure TfmCircleEd.btObjDeleteClick(Sender: TObject);
Var
   LO,
   i : Integer;
begin
     if (ObjZone = -1) or (CurObj = -1) then exit;
     LO := Length(Objects);
     if LO < 1 then exit;
     if MessageDlg( 'Delete Current Object','Delete Current Object',mtConfirmation,[mbYes,mbNo],0) = mrYes then
     Begin
          lbObj.Items.Delete(CurObj);

          for i := CurObj to LO-2 do
          Begin
               Objects[i] := ObjEquals(Objects[i+1]);
          End;
          SetLength(Objects,LO-1);
          if LO > 1 then
          Begin
               ObjToGUI(0);
               lbObj.Sort;
               lbObj.Selected[0] := true;
          End;
     End;     
end;

{Button Clone Object Click}
{Copy the selected Object to a new one}
procedure TfmCircleEd.btObjCloneClick(Sender: TObject);
Var
   NrofObj,
   NewVNum,
   PrevObj,
   i  : Integer;
begin
     if (ObjZone = -1) or (CurObj = -1) then exit;
     if MessageDlg( 'Clone Object','Clone selected Object>',mtConfirmation,[mbYes,mbNo],0) = mrYes then
     Begin
          PrevObj := CurObj;
          NewVNum := -1;
          for i := 0 to 99 do
          Begin
               if (ObjectPos((ObjZone*100)+ i) = -1) then
               Begin
                    NewVNum := (ObjZone*100)+ i;
                    NrofObj := NewObj(NewVNum);
                    CurObj := NrofObj;
                    break;
               End;
               if i = 99 then
               Begin
                    MessageDlg('No more open spots in Zone','No more open spots in Zone',mtInformation,[mbOK],0);
                    exit;
               End;
          End;
          if NewVNum = -1 then exit;
          Objects[CurObj] := ObjEquals(Objects[PrevObj]);
          Objects[CurObj].Vnum := NewVNum;
          ObjToGUI(CurObj);

          lbObj.Items.Add(IntToStr(NewVNum));
          lbObj.Sort;
          lbObj.Selected[ObjectPos((ObjZone*100)+ i)] := true;
     End;     
end;

{--Mobile GUI--}

{Spin Edit Mobile Alignment changed}
{Change to spin edits color like allinment}
procedure TfmCircleEd.seMobAlignChanged(Sender: TObject;
  NewValue: Integer);
begin
     case NewValue of
      -1000..-350 : seMobAlign.Color := clRed;
       -349..349  : seMobAlign.Color := clBase;
       350..1000  : seMobAlign.Color := clLime;
     end;

end;

{String Grid E Specs Key press}
{Create new String grid line and keep second column a number} 
procedure TfmCircleEd.ssgMobESpecsKeyPress(Sender: TObject; var Key: Char);
begin

end;
{Check Listbox Load Position Click Check}
{Simulate Radiobutton}
procedure TfmCircleEd.chlbMobLoadPosClickCheck(Sender: TObject);
Var
   i,
   II : Integer;
begin
     //Change the checkbox listbox into a radio listbox
     II := TCheckListBox(Sender).ItemIndex;
     for i := 0 to TCheckListBox(Sender).Items.Count-1 do
         TCheckListBox(Sender).Checked[i] := false;
     TCheckListBox(Sender).Checked[II] := true;
     TCheckListBox(Sender).ItemIndex := II;
end;

{Radio button Mobile S, Mobile E click}
{Enable and Disbale ESpecs String Grid}
procedure TfmCircleEd.rbMobSClick(Sender: TObject);
Var
   SorE : Boolean; // True = E
begin
     if rbMobS.Checked then SorE := false
     else SorE := true;
     lbMobESpecs.Enabled := SorE;
     Label41.Enabled     := SorE
end;

{...etc}
procedure TfmCircleEd.lbMobClick(Sender: TObject);
Var
   Num : Integer;
begin
     if lbMob.Items.Count < 1 then exit;
     Num := MobilePos(StrToInt(lbMob.Items[lbMob.ItemIndex]) );
     if Num >= 0 then
       MobToGUI(Num);  
end;

procedure TfmCircleEd.edMobFindChange(Sender: TObject);
Var
   i : Integer;
begin
     if edMobFind.Text = '' then Exit;
     if lbMob.Items.Count < 1 then Exit;
     for i := 0 to lbMob.Items.Count-1 do
     Begin
          if StartWith(edMobFind.Text,lbMob.Items[i]) then
          Begin
               lbMob.Selected[i] := true;
               MobToGui(i);
               Exit;
          End;
     End;
end;

procedure TfmCircleEd.btMobnewClick(Sender: TObject);
Var
   i,NewVNum,
   NrofMob   : Integer;
begin
     if MobZone = -1 then exit; //Do new Object file
     for i := 0 to 99 do
     Begin
          if (MobilePos((MobZone*100)+ i) = -1) then
          Begin
               NewVNum := (MobZone*100)+ i;
               NrofMob := NewMob(NewVNum);
               lbMob.Items.Add(IntToStr(NewVNum));
               MobToGUI(NrofMob);
               lbMob.Sort;
               
               lbMob.Selected[MobilePos((MobZone*100)+ i)] := true;
               Exit;
          End;
     End;
end;

{Change extention based on world direcectory}
procedure TfmCircleEd.OpenObjectFile1Click(Sender: TObject);
begin
     OpenDialog1.FilterIndex := 1;
     Load1Click(Sender);
end;

procedure TfmCircleEd.OpenMobileFile1Click(Sender: TObject);
begin
     OpenDialog1.FilterIndex := 2;
     Load1Click(Sender);
end;

procedure TfmCircleEd.OpenWorldFile1Click(Sender: TObject);
begin
     OpenDialog1.FilterIndex := 3;
     Load1Click(Sender);
end;

procedure TfmCircleEd.OpenZoneFile1Click(Sender: TObject);
begin
     OpenDialog1.FilterIndex := 4;
     Load1Click(Sender);
end;

procedure TfmCircleEd.OpenShopFile1Click(Sender: TObject);
begin
     OpenDialog1.FilterIndex := 5;
     Load1Click(Sender);
end;

procedure TfmCircleEd.btMobDeleteClick(Sender: TObject);
Var
   LO,
   i : Integer;
begin
     if (MobZone = -1) or (CurMob = -1) then exit;
     LO := Length(Mobiles);
     if LO < 1 then exit;
     if MessageDlg( 'Delete Current Mobile','Delete Current Mobile',mtConfirmation,[mbYes,mbNo],0) = mrYes then
     Begin
          lbMob.Items.Delete(CurMob);

          for i := CurMob to LO-2 do
          Begin
               Mobiles[i] := MobEquals(Mobiles[i+1]);
          End;
          SetLength(Mobiles,LO-1);
          if LO > 1 then
          Begin
               MobToGUI(0);
               lbMob.Sort;
               lbMob.Selected[0] := true;
          End;
     End;
end;

procedure TfmCircleEd.btMobCloneClick(Sender: TObject);
Var
   NrofMob,
   NewVNum,
   PrevMob,
   i  : Integer;
begin
     if (MobZone = -1) or (CurMob = -1) then exit;
     if MessageDlg( 'Clone Mobile','Clone selected Mobile>',mtConfirmation,[mbYes,mbNo],0) = mrYes then
     Begin
          PrevMob := CurMob;
          NewVNum := -1;
          for i := 0 to 99 do
          Begin
               if (MobilePos((MobZone*100)+ i) = -1) then
               Begin
                    NewVNum := (MobZone*100)+ i;
                    NrofMob :=  NewMob(NewVNum);
                    CurMob  :=  NrofMob;
                    break;
               End;
               if i = 99 then
               Begin
                    MessageDlg('No more open spots in Zone','No more open spots in Zone',mtInformation,[mbOK],0);
                    exit;
               End;
          End;
          if NewVNum = -1 then exit;
          Mobiles[CurMob] := MobEquals(Mobiles[PrevMob]);
          Mobiles[CurMob].Vnum := NewVNum;
          MobToGUI(CurMob);

          lbMob.Items.Add(IntToStr(NewVNum));
          lbMob.Sort;
          lbMob.Selected[MobilePos((MobZone*100)+ i)] := true;
     End;
end;

procedure TfmCircleEd.btMobVNumClick(Sender: TObject);
Var
   min,
   CVNum,
   NewVNum : Integer;
begin
     if CurMob = -1 then exit; //Change to New Later
     CVnum := Mobiles[CurMob].Vnum;
     min := (CVnum div 100)*100;
     Repeat
           NewVNum := InputBox('Enter new VNum','New VNum:',CVnum,min,min+99,1);
     Until (MobilePos(NewVnum) = -1) or (NewVNum = CVnum);   //Check if new VNUM Exits
     lbMob.Items[MobilePos(CVNum)] := IntToStr(NewVNum);
     Mobiles[CurMob].Vnum := NewVNum;
     MobToGUI(MobilePos(NewVNum));
     edMobVNum.Text := IntToStr(NewVNum);
     lbMob.Sort
end;

procedure TfmCircleEd.btMobAcceptClick(Sender: TObject);
begin
     if (MobZone = -1) or (CurMob = -1) or (lbMob.Rows = 0) then exit;
     Mobiles[CurMob] := MobGUItoMem;
end;

procedure TfmCircleEd.NewMobileFile2Click(Sender: TObject);
Var
   FN : Integer;
begin
     FN := InputBox('Mobile File Name','Enter Filename(Number)',0,0,999,1);
     if FN <> 0 then
     Begin
          MobZone := FN;
          Label18.Caption := IntToStr(FN)+'.obj';
          SetLength(Mobiles,0);
          ShowMobList;
     End;
end;

procedure TfmCircleEd.SaveMobileFile1Click(Sender: TObject);
Var
   i  : integer;
begin
     if (CurMob = -1) or (MobZone = -1) then exit;
     SaveDialog1.InitialDir  := Options.Strings[0];
     SaveDialog1.FileName    := IntToStr(MobZone)+'.mob';
     SaveDialog1.FilterIndex := 2;
     if SaveDialog1.Execute then
     Begin
          MobSort;
          MobFile.Clear;
          for i := 0 to Length(Mobiles)-1 do
          Begin
               MobFile.AddStrings(RenderMob(Mobiles[i]) );
          End;
          MobFile.Add('$');
          MobFile.SaveToFile(SaveDialog1.FileName);
     End;
end;
{To draw images in grid}
{
procedure TfmCircleEd.sgWorldDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
Var
   BM : TBitmap;
begin
     BM := TBitmap.Create;
     if (ACol = 1) and (ARow = 1)  then
     Begin
          BM.LoadFromFile('grid.bmp');
          //sgWorld.Canvas.MoveTo(Rect.Left,Rect.Top);
          //sgWorld.Canvas.LineTo(Rect.Right,Rect.Bottom);
          sgWorld.Canvas.Draw(Rect.Left,Rect.Top,BM);
          sgWorld.Canvas.Font.Name := 'Arial';
          sgWorld.Canvas.Font.Size := 8;
          sgWorld.Canvas.TextOut(Rect.Left+0,Rect.bottom-12,'151234');
     End;
end;}

procedure TfmCircleEd.btWldDFaddClick(Sender: TObject);
Var
   DirField : TDirField;
   Dnum,
   i        : integer;
begin
     if CurWld = -1 then exit;
     DirField.GenDesc := TStringList.Create;
     DirField.DirNum       := 0;
     DirField.GenDesc.Text := 'You see nothing.';
     DirField.Keywords     := '';
     DirField.DoorFlag     := 0;
     DirField.KeyNum       := 0;
     DirField.RoomLinked   := -1;
     fmWldDirField.DirField := DirFieldEquals(DirField);
     if fmWldDirField.ShowModal = mrOK then
     Begin
          DirField := DirFieldEquals(fmWldDirField.DirField);
          Dnum := Length(WldDir);
          for i := 0 to Dnum-1 do
          Begin
               if DirField.DirNum = WldDir[i].DirNum then
               Begin
                    MessageDlg('Duplicate Direction','Duplicate Direction',mtError,[mbOK],0);
                    Exit;
               End;
          End;
          SetLength(WldDir,Dnum+1);
          WldDir[Dnum] := DirFieldEquals(DirField);
          WldShowDir;
     End;
end;

procedure TfmCircleEd.btWldEDAddClick(Sender: TObject);
var
   WldExtDesc : TWldExtDesc;
   num        : integer;
begin
     if CurWld = -1 then exit;
     WldExtDesc.Desc := TStringList.Create;
     WldExtDesc.Keyword   := 'something';
     WldExtDesc.Desc.Text := 'You see something';
     fmWldExtraDesc.ExtDesc := WldExtraDescEquals(WldExtDesc);
     if fmWldExtraDesc.ShowModal = mrOK then
     Begin
          WldExtDesc := WldExtraDescEquals(fmWldExtraDesc.ExtDesc);
          num := Length(WldExt);
          SetLength(WldExt,num+1);
          WldExt[num] := WldExtraDescEquals(fmWldExtraDesc.ExtDesc);
          WldShowExt;
     End;
end;

procedure TfmCircleEd.edWldFindChange(Sender: TObject);
Var
   i : Integer;
begin
     if edWldFind.Text = '' then Exit;
     if lbWld.Items.Count < 1 then Exit;
     for i := 0 to lbMob.Items.Count-1 do
     Begin
          if StartWith(edWldFind.Text,lbWld.Items[i]) then
          Begin
               lbWld.Selected[i] := true;
               //todo grid
               WldToGui(i);
               Exit;
          End;
     End;
end;

procedure TfmCircleEd.btWldVNumClick(Sender: TObject);
Var
   min,
   CVNum,
   NewVNum : Integer;
begin
     if CurWld = -1 then exit;
     CVnum := Worlds[CurMob].Vnum;
     min := (CVnum div 100)*100;
     Repeat
           NewVNum := InputBox('Enter new VNum','New VNum:',CVnum,min,min+99,1);
     Until (WorldPos(NewVnum) = -1) or (NewVNum = CVnum);   //Check if new VNUM Exits
     lbWld.Items[WorldPos(CVNum)] := IntToStr(NewVNum);
     Worlds[CurWld].Vnum := NewVNum;
     WldToGUI(WorldPos(NewVNum));
     edWldVNum.Text := IntToStr(NewVNum);
     lbWld.Sort
end;

procedure TfmCircleEd.lbWldClick(Sender: TObject);
Var
   Num : Integer;
begin
     if lbWld.Items.Count < 1 then exit;
     Num := WorldPos(StrToInt(lbWld.Items[lbWld.ItemIndex]) );
     if Num >= 0 then
       WldToGUI(Num);
end;

procedure TfmCircleEd.chlbWldSectorFlagClickCheck(Sender: TObject);
Var
   i,
   II : Integer;
begin
     //Change the checkbox listbox into a radio listbox
     II := chlbWldSectorFlag.ItemIndex;
     for i := 0 to chlbWldSectorFlag.Items.Count-1 do
         chlbWldSectorFlag.Checked[i] := false;
     chlbWldSectorFlag.Checked[II] := true;
     chlbWldSectorFlag.ItemIndex := II;
end;



procedure TfmCircleEd.NewWorldFile3Click(Sender: TObject);
Var
   FN : Integer;
begin
     FN := InputBox('World File Name','Enter Filename(Number)',0,0,999,1);
     if FN <> 0 then
     Begin
          WldZone := FN;
          Label42.Caption := IntToStr(FN)+'.wld';
          SetLength(Worlds,0);
          ShowWldList;
     End;
end;

procedure TfmCircleEd.btWldDFEditClick(Sender: TObject);
Var
   DirField : TDirField;
   Dnum,
   i        : integer;
begin
     if lbWldDirF.itemindex < 0 then exit;
     DirField := DirFieldEquals(WldDir[lbWldDirF.itemindex]);
     fmWldDirField.DirField := DirFieldEquals(DirField);
     if fmWldDirField.ShowModal = mrOK then
     Begin
          DirField := fmWldDirField.DirField;
          Dnum := Length(WldDir);
          for i := 0 to Dnum-1 do
          Begin
               if (DirField.DirNum = WldDir[i].DirNum) and (i <> lbWldDirF.itemindex) then
               Begin
                    MessageDlg('Duplicate Direction','Duplicate Direction',mtError,[mbOK],0);
                    Exit;
               End;
          End;
          WldDir[lbWldDirF.itemindex] := DirFieldEquals(DirField);
          WldShowDir;
     End;
end;

procedure TfmCircleEd.btWldDFDeleteClick(Sender: TObject);
Var
   ln,
   i : Integer;
begin
     if lbWldDirF.itemindex < 0 then exit;
     ln := Length(WldDir);
     for i := lbWldDirF.itemindex to ln-2 do
     Begin
          WldDir[i] := DirFieldEquals(WldDir[i+1]);
     End;
     SetLength(WldDir,ln-1);
     WldShowDir;
end;

procedure TfmCircleEd.btWldEDDeleteClick(Sender: TObject);
Var
   ln,
   i : Integer;
begin
     if CurWld = -1 then exit;
     if lbWldED.itemindex < 0 then exit;
     ln := Length(WldExt);
     for i := lbWldED.itemindex to ln-2 do
     Begin
          WldExt[i] := WldExtraDescEquals(WldExt[i+1]);
     End;
     SetLength(WldExt,ln-1);
     WldShowExt;
end;

procedure TfmCircleEd.btWldEDEditClick(Sender: TObject);
Var
   WldExtDesc : TWldExtDesc;
begin
     if CurWld = -1 then exit;
     if lbWldED.itemindex < 0 then exit;
     WldExtDesc := WldExtraDescEquals(WldExt[lbWldED.itemindex]);
     fmWldExtraDesc.ExtDesc := WldExtraDescEquals(WldExtDesc);
     if fmWldExtraDesc.ShowModal = mrOK then
     Begin
          WldExtDesc := fmWldExtraDesc.ExtDesc;
          WldExt[lbWldED.itemindex] := WldExtraDescEquals(WldExtDesc);
          WldShowExt;
     End;
end;

procedure TfmCircleEd.btWldNewClick(Sender: TObject);
Var
   i,NewVNum,
   NrofWld   : Integer;
begin
     if WldZone = -1 then exit; //Do new Object file
     for i := 0 to 99 do
     Begin
          if (WorldPos((WldZone*100)+ i) = -1) then
          Begin
               NewVNum := (WldZone*100)+ i;
               NrofWld := NewWld(NewVNum);
               lbWld.Items.Add(IntToStr(NewVNum));
               WldToGUI(NrofWld);
               lbWld.Sort;

               lbWld.Selected[WorldPos((WldZone*100)+ i)] := true;
               Exit;
          End;
     End;
end;

procedure TfmCircleEd.btWldDeleteClick(Sender: TObject);
Var
   LO,
   i : Integer;
begin
     if (WldZone = -1) or (CurWld = -1) then exit;
     LO := Length(Worlds);
     if LO < 1 then exit;
     if MessageDlg( 'Delete Current Room','Delete Current Room',mtConfirmation,[mbYes,mbNo],0) = mrYes then
     Begin
          lbWld.Items.Delete(CurWld);
          //Todo Delete Grid
          for i := CurWld to LO-2 do
          Begin
                Worlds[i] := WldEquals(Worlds[i+1]);
          End;
          SetLength(Worlds,LO-1);
          if LO > 1 then
          Begin
               WldToGUI(0);
               lbWld.Sort;
               lbWld.Selected[0] := true;
          End;
     End;
end;

procedure TfmCircleEd.btWldCloneClick(Sender: TObject);
Var
   NrofWld,
   NewVNum,
   PrevWld,
   i  : Integer;
begin
     if (WldZone = -1) or (CurWld = -1) then exit;
     if MessageDlg( 'Clone Room','Clone selected Room>',mtConfirmation,[mbYes,mbNo],0) = mrYes then
     Begin
          PrevWld := CurWld;
          NewVNum := -1;
          for i := 0 to 99 do
          Begin
               if (WorldPos((WldZone*100)+ i) = -1) then
               Begin
                    NewVNum := (WldZone*100)+ i;
                    NrofWld :=  NewWld(NewVNum);
                    CurWld  :=  NrofWld;
                    break;
               End;
               if i = 99 then
               Begin
                    MessageDlg('No more open spots in Zone','No more open spots in Zone',mtInformation,[mbOK],0);
                    exit;
               End;
          End;
          if NewVNum = -1 then exit;
          Worlds[CurWld] := WldEquals(Worlds[PrevWld]);
          Worlds[CurWld].Vnum := NewVNum;
          WldToGUI(CurWld);

          lbWld.Items.Add(IntToStr(NewVNum));
          lbWld.Sort;
          lbWld.Selected[WorldPos((WldZone*100)+ i)] := true;
     End;
end;

procedure TfmCircleEd.btWldAcceptClick(Sender: TObject);
begin
     if (WldZone = -1) or (CurWld = -1) or (lbWld.Rows = 0) then exit;
     Worlds[CurWld] := WldGUItoMem;
end;

procedure TfmCircleEd.SaveWorldFile1Click(Sender: TObject);
Var
   i  : integer;
begin
     if (CurWld = -1) or (WldZone = -1) then exit;
     SaveDialog1.InitialDir  := Options.Strings[0];
     SaveDialog1.FileName    := IntToStr(WldZone)+'.wld';
     SaveDialog1.FilterIndex := 3;
     if SaveDialog1.Execute then
     Begin
          WldSort;
          WldFile.Clear;
          for i := 0 to Length(Worlds)-1 do
          Begin
               WldFile.AddStrings(RenderWld(Worlds[i]) );
          End;
          WldFile.Add('$');
          WldFile.SaveToFile(SaveDialog1.FileName);
     End;
end;

procedure TfmCircleEd.sgShpItemsKeyPress(Sender: TObject; var Key: Char);
begin
     NumOnly(Key,false);
     if sgShpItems.Row = sgShpItems.RowCount-1 then
        sgShpItems.RowCount := sgShpItems.RowCount+1;
end;

procedure TfmCircleEd.sgShpRoomsKeyPress(Sender: TObject;
  var Key: Char);
begin
     NumOnly(Key,false);
     if sgShpRooms.Row = sgShpRooms.RowCount-1 then
        sgShpRooms.RowCount := sgShpRooms.RowCount+1;
end;

procedure TfmCircleEd.edShpFindChange(Sender: TObject);
Var
   i : Integer;
begin
     if edShpFind.Text = '' then Exit;
     if lbShp.Items.Count < 1 then Exit;
     for i := 0 to lbShp.Items.Count-1 do
     Begin
          if StartWith(edShpFind.Text,lbShp.Items[i]) then
          Begin
               lbShp.Selected[i] := true;
               ShpToGui(i);
               Exit;
          End;
     End;
end;

procedure TfmCircleEd.NewShopFile5Click(Sender: TObject);
Var
   FN : Integer;
begin
     FN := InputBox('Shop File Name','Enter Filename(Number)',0,0,999,1);
     if FN <> 0 then
     Begin
          ShpZone := FN;
          Label51.Caption := IntToStr(FN)+'.shp';
          SetLength(Shops,0);
          ShowShpList;
     End;
end;

procedure TfmCircleEd.edShpProfitSellKeyPress(Sender: TObject;
  var Key: Char);
begin
     NumOnlyE(Key,true,false);
end;

procedure TfmCircleEd.chlbShpTemperFlagsClickCheck(Sender: TObject);
Var
   i,
   II : Integer;
begin
     //Change the checkbox listbox into a radio listbox
     II := chlbShpTemperFlags.ItemIndex;
     for i := 0 to chlbShpTemperFlags.Items.Count-1 do
         chlbShpTemperFlags.Checked[i] := false;
     chlbShpTemperFlags.Checked[II] := true;
     chlbShpTemperFlags.ItemIndex := II;
end;

procedure TfmCircleEd.lbShpClick(Sender: TObject);
Var
   Num : Integer;
begin
     if lbShp.Items.Count < 1 then exit;
     Num := ShopPos(StrToInt(lbShp.Items[lbShp.ItemIndex]) );
     if Num >= 0 then
        ShpToGUI(Num);
end;

procedure TfmCircleEd.btShpVNumClick(Sender: TObject);
Var
   min,
   CVNum,
   NewVNum : Integer;
begin
     if CurShp = -1 then exit;
     CVnum := Shops[CurShp].Vnum;
     min := (CVnum div 100)*100;
     Repeat
           NewVNum := InputBox('Enter new VNum','New VNum:',CVnum,min,min+99,1);
     Until (ShopPos(NewVnum) = -1) or (NewVNum = CVnum);   //Check if new VNUM Exits
     lbShp.Items[ShopPos(CVNum)] := IntToStr(NewVNum);
     Shops[CurShp].Vnum := NewVNum;
     ShpToGUI(ShopPos(NewVNum));
     edShpVNum.Text := IntToStr(NewVNum);
     lbShp.Sort
end;

procedure TfmCircleEd.btShpNewClick(Sender: TObject);
Var
   i,NewVNum,
   NrofShp   : Integer;
begin
     if ShpZone = -1 then exit; //Do new Object file
     for i := 0 to 99 do
     Begin
          if (ShopPos((ShpZone*100)+ i) = -1) then
          Begin
               NewVNum := (ShpZone*100)+ i;
               NrofShp := NewShp(NewVNum);  
               lbShp.Items.Add(IntToStr(NewVNum));
               ShpToGUI(NrofShp);
               lbShp.Sort;

               lbShp.Selected[ShopPos((ShpZone*100)+ i)] := true;
               Exit;
          End;
     End;
end;

procedure TfmCircleEd.btShpDeleteClick(Sender: TObject);
Var
   LO,
   i : Integer;
begin
     if (ShpZone = -1) or (CurShp = -1) then exit;
     LO := Length(Shops);
     if LO < 1 then exit;
     if MessageDlg( 'Delete Current Shop','Delete Current Shop',mtConfirmation,[mbYes,mbNo],0) = mrYes then
     Begin
          lbShp.Items.Delete(CurShp);
          for i := CurShp to LO-2 do
          Begin
                Shops[i] := ShpEquals(Shops[i+1]);
          End;
          SetLength(Shops,LO-1);
          if LO > 1 then
          Begin
               ShpToGUI(0);
               lbShp.Sort;
               lbShp.Selected[0] := true;
          End;
     End;
end;

procedure TfmCircleEd.btShpCloneClick(Sender: TObject);
Var
   NrofShp,
   NewVNum,
   PrevShp,
   i  : Integer;
begin
     if (ShpZone = -1) or (CurShp = -1) then exit;
     if MessageDlg( 'Clone Shop','Clone selected Shop?',mtConfirmation,[mbYes,mbNo],0) = mrYes then
     Begin
          PrevShp := CurShp;
          NewVNum := -1;
          for i := 0 to 99 do
          Begin
               if (ShopPos((ShpZone*100)+ i) = -1) then
               Begin
                    NewVNum := (ShpZone*100)+ i;
                    NrofShp :=  NewShp(NewVNum);
                    CurShp  :=  NrofShp;
                    break;
               End;
               if i = 99 then
               Begin
                    MessageDlg('No more open spots in Zone','No more open spots in Zone',mtInformation,[mbOK],0);
                    exit;
               End;
          End;
          if NewVNum = -1 then exit;
          Shops[CurShp] := ShpEquals(Shops[PrevShp]);
          Shops[CurShp].Vnum := NewVNum;
          ShpToGUI(CurShp);

          lbShp.Items.Add(IntToStr(NewVNum));
          lbShp.Sort;
          lbShp.Selected[ShopPos((ShpZone*100)+ i)] := true;
     End;
end;

procedure TfmCircleEd.btShpAcceptClick(Sender: TObject);
begin
     if (ShpZone = -1) or (CurShp = -1) or (lbShp.Rows = 0) then exit;
     Shops[CurShp] := ShpGUItoMem;
end;

procedure TfmCircleEd.SaveShopFile2Click(Sender: TObject);
Var
   i  : integer;
begin
     if (CurShp = -1) or (ShpZone = -1) then exit;
     SaveDialog1.InitialDir  := Options.Strings[0];
     SaveDialog1.FileName    := IntToStr(ShpZone)+'.shp';
     SaveDialog1.FilterIndex := 5;
     if SaveDialog1.Execute then
     Begin
          ShpSort;
          ShpFile.Clear;
          ShpFile.Add('CircleMUD v3.0 Shop File~');
          for i := 0 to Length(Shops)-1 do
          Begin
               ShpFile.AddStrings(RenderShp(Shops[i]) );
          End;
          ShpFile.Add('$~');
          ShpFile.SaveToFile(SaveDialog1.FileName);
     End;
end;

procedure TfmCircleEd.btShpAddBTClick(Sender: TObject);
var
   num,i    : integer;
   p1,p2    : String;
begin
     if (ShpZone = -1) or (CurShp = -1) then exit;
     if chlbTypeFlags.Items.Count > 0 then
     Begin
          GetParams(chlbTypeFlags.Items[0],[@p1,@p2]);
          fmShpBuyTypes.BuyTypes.BuyType := UpperCase(p2);
     End Else fmShpBuyTypes.BuyTypes.BuyType := 'LIGHT';
     fmShpBuyTypes.BuyTypes.BuyList := '';
     if fmShpBuyTypes.ShowModal = mrOK then
     Begin
          for i := 0 to Length(ShpBuy)-1 do
          Begin
               if fmShpBuyTypes.BuyTypes.BuyType = ShpBuy[i].BuyType then
               Begin
                    MessageDlg('Item Type all ready in list','Item Type all ready in list',mtError,[mbOK],0);
                    Exit;
               End;
          End;
          num := Length(ShpBuy);
          SetLength(ShpBuy,num+1);
          ShpBuy[num].BuyType := fmShpBuyTypes.BuyTypes.BuyType;
          ShpBuy[num].BuyList := fmShpBuyTypes.BuyTypes.BuyList;
          lbBuyTypes.Clear;
          for i:= 0 to Length(ShpBuy)-1 do
               lbBuyTypes.Items.Add(ShpBuy[i].BuyType);
     End;
end;

procedure TfmCircleEd.btShpDeleteBTClick(Sender: TObject);
Var
   ln,
   i : Integer;
begin
     if (ShpZone = -1) or (CurShp = -1) then exit;
     if lbBuyTypes.itemindex < 0 then exit;
     ln := Length(ShpBuy);
     for i := lbBuyTypes.itemindex to ln-2 do
     Begin
          ShpBuy[i].BuyType := ShpBuy[i+1].BuyType;
          ShpBuy[i].BuyList := ShpBuy[i+1].BuyList
     End;
     SetLength(ShpBuy,ln-1);
     lbBuyTypes.Clear;
     for i:= 0 to Length(ShpBuy)-1 do
         lbBuyTypes.Items.Add(ShpBuy[i].BuyType);
end;

procedure TfmCircleEd.btShpChangeBTClick(Sender: TObject);
Var
   i : integer;
begin
     if (ShpZone = -1) or (CurShp = -1) then exit;
     if lbBuyTypes.itemindex < 0 then exit;
     fmShpBuyTypes.BuyTypes.BuyType := ShpBuy[lbBuyTypes.ItemIndex].BuyType;
     fmShpBuyTypes.BuyTypes.BuyList := ShpBuy[lbBuyTypes.ItemIndex].BuyList;
     if fmShpBuyTypes.ShowModal = mrOK then
     Begin
          for i := 0 to Length(ShpBuy)-1 do
          Begin
               if fmShpBuyTypes.BuyTypes.BuyType = ShpBuy[i].BuyType then
               Begin
                    MessageDlg('Item Type all ready in list','Item Type all ready in list',mtError,[mbOK],0);
                    Exit;
               End;
          End;
          ShpBuy[lbBuyTypes.itemindex].BuyType := fmShpBuyTypes.BuyTypes.BuyType;
          ShpBuy[lbBuyTypes.itemindex].BuyList := fmShpBuyTypes.BuyTypes.BuyList;
          lbBuyTypes.Clear;
          for i:= 0 to Length(ShpBuy)-1 do
              lbBuyTypes.Items.Add(ShpBuy[i].BuyType);
     End;
end;

procedure TfmCircleEd.cbZonCommandChange(Sender: TObject);
Var
   Vnum,
   Par3,
   Par4   : String;
begin
     labIf.Caption := 'If Flag';
     seZonPar4.Visible := True;
     cbZonPar4.Visible := False;
     seZonPar3.Visible := True;
     cbZonPar3.Visible := False;
     Case cbZonCommand.ItemIndex of
       0 : Begin    //Load Mobile  M
                VNum := 'Mob VNum';
                Par3 := 'Max Existing';
                Par4 := 'Room VNum';
                seZonIF.Value := 0;
           End;
       1 : Begin    //Load Object  O
                VNum := 'Obj VNum';
                Par3 := 'Max Existing';
                Par4 := 'Room VNum';
                seZonIF.Value := 0;
           End;
       2 : Begin    //give object to mobile G
                VNum := 'Obj VNum';
                Par3 := 'Max Existing';
                Par4 := 'None';
                seZonIF.Value := 1;
           End;
       3 : Begin    //equip mobile with object E
                VNum := 'Obj VNum';
                Par3 := 'Max Existing';
                Par4 := 'Equipment Pos';

                cbZonPar4.Items.Clear;
                cbZonPar4.Items.AddStrings(LoadFlags('Zone_WearFlag'));
                if cbZonPar4.Items.Count > 0 then
                     cbZonPar4.ItemIndex := 0;
                seZonPar4.Visible := False;
                cbZonPar4.Visible := True;
                seZonIF.Value := 1;
           End;
       4 : Begin    //put object in object P
                VNum := 'Obj VNum1';
                Par3 := 'Max Existing';
                Par4 := 'Obj VNum2';
                seZonIF.Value := 1;
           End;
       5 : Begin    //set the state of a door  D
                VNum := 'Room VNum';
                Par3 := 'Exit Num';
                Par4 := 'State';

                cbZonPar4.Items.Clear;
                cbZonPar4.Items.AddStrings(LoadFlags('Zone_DoorFlag'));
                if cbZonPar4.Items.Count > 0 then
                   cbZonPar4.ItemIndex := 0;
                seZonPar4.Visible := False;
                cbZonPar4.Visible := True;
                seZonPar3.Visible := False;
                cbZonPar3.Visible := True;
           End;
       6 : Begin    //remove object from room  R
                VNum := 'Room VNum';
                Par3 := 'Obj Vnum';
                Par4 := 'None';
           End;
       7 : Begin    //Comment Line
                labIf.Caption := 'None';
                VNum := 'None';
                Par3 := 'None';
                Par4 := 'None';
                seZonPar4.Enabled := true;
           End;
     End;
     labVNum.Caption := VNum;
     labPar3.Caption := Par3;
     labPar4.Caption := Par4;

end;

procedure TfmCircleEd.btZonVNumClick(Sender: TObject);
Var
   NewVNum : Integer;
begin
     if CurZon = -1 then exit;
     NewVNum := InputBox('Enter new VNum','New VNum:',CurZon);
     Label76.Caption := IntToStr(NewVNum)+'.zon';
     edZonVNum.Text := IntToStr(NewVNum);
     CurZon := NewVNum;
end;

procedure TfmCircleEd.NewZoneFile4Click(Sender: TObject);
Var
   FN : Integer;
begin
     FN := InputBox('Zone File Name','Enter Filename(Number)',0,0,999,1);
     if FN <> 0 then
     Begin
          ZonZone := FN;
          CurZon  := FN;
          Label76.Caption := IntToStr(FN)+'.zon';
          Zone.VNum := FN;
          Zone.BottomRoom := FN*100;
          Zone.TopRoom    := FN*100+99;
          SetLength(Zone.Commands,0);
          lbZone.Clear;
          ShowZoneInfo;
     End;
end;

procedure TfmCircleEd.btZonAddClick(Sender: TObject);
begin
     if CurZon = -1 then exit;
     InsertCommand(-1);
     ShowCommandList;
end;

procedure TfmCircleEd.btZonInsertClick(Sender: TObject);
begin
     if (CurZon = -1) then exit;
     InsertCommand(lbZone.ItemIndex);
     ShowCommandList;
end;

procedure TfmCircleEd.btZonUpClick(Sender: TObject);
Var
   TempCom : TZonCom;
   NP      : Integer;
begin
      if (CurZon = -1) then exit;
     if lbZone.ItemIndex < 1 then exit;
     TempCom := Zone.Commands[lbZone.ItemIndex-1];
     Zone.Commands[lbZone.ItemIndex-1] := Zone.Commands[lbZone.ItemIndex];
     Zone.Commands[lbZone.ItemIndex]   := TempCom;
     NP := lbZone.ItemIndex-1;
     ShowCommandList;
     lbZone.ItemIndex := NP;
end;

procedure TfmCircleEd.btZonDownClick(Sender: TObject);
Var
   TempCom : TZonCom;
   NP      : Integer;
begin
      if (CurZon = -1) then exit;
     if (lbZone.ItemIndex = -1) or (lbZone.ItemIndex = lbZone.Items.Count-1) then exit;
     TempCom := Zone.Commands[lbZone.ItemIndex+1];
     Zone.Commands[lbZone.ItemIndex+1] := Zone.Commands[lbZone.ItemIndex];
     Zone.Commands[lbZone.ItemIndex]   := TempCom;
     NP := lbZone.ItemIndex+1;
     ShowCommandList;
     lbZone.ItemIndex := NP;
end;

procedure TfmCircleEd.btZonChangeClick(Sender: TObject);
begin
      if (CurZon = -1) then exit;
     ChangeCommand(lbZone.ItemIndex);
     ShowCommandList;
end;

procedure TfmCircleEd.btZonDeleteClick(Sender: TObject);
var
   num,
   i  : integer;
begin
       if (CurZon = -1) then exit;
      if (lbZone.ItemIndex < 0) then exit;
      num := Length(Zone.Commands);
      if num > 0 then
      Begin
           for i := lbZone.ItemIndex to num-2 do
               Zone.Commands[i] := Zone.Commands[i+1];
           SetLength(Zone.Commands,num-1);
      End;
      ShowCommandList;
end;

procedure TfmCircleEd.lbZoneClick(Sender: TObject);
begin
     if (lbZone.ItemIndex < 0) or (ZonZone < 0) then exit;
     ZonComGUI(lbZone.ItemIndex);  //Double else itemindex is made zero and command is not yet.should make it two procs
     cbZonCommandChange(Sender);
     ZonComGUI(lbZone.ItemIndex);
end;

procedure TfmCircleEd.btZonCloneClick(Sender: TObject);
var
   MobBeg,
   MobEnd,
   i,num    : integer;
   LObj     : String[1];
begin
     if (lbZone.ItemIndex < 0)        or
        (cbZonCommand.ItemIndex <> 0) or //Mobile
        (ZonZone < 0)                 then exit;
     MobBeg := lbZone.ItemIndex;
     num    := Length(Zone.Commands);
     if MobBeg < num-1 then
     Begin
          MobEnd := num-1;
          for i := MobBeg+1 to num-1 do
          Begin
               if (Zone.Commands[i].Command = 'M') then
               Begin
                    MobEnd := i-1;
                    break;
               End;
          End;
     end Else MobEnd := MobBeg;
     SetLength(Zone.Commands,num+1);
     Zone.Commands[num] := Zone.Commands[MobBeg];
     for i := MobBeg+1 to MobEnd do
     Begin
          num    := Length(Zone.Commands);
          if (Zone.Commands[i].Command = 'E') or
             (Zone.Commands[i].Command = 'G') then
          Begin
               SetLength(Zone.Commands,num+1);
               Zone.Commands[num] := Zone.Commands[i];
          End;
          if (Zone.Commands[i].Command = 'P') and
             (LObj = 'G')                     then
          Begin
               SetLength(Zone.Commands,num+1);
               Zone.Commands[num] := Zone.Commands[i];
          End;
          if (Zone.Commands[i].Command = 'O') or
             (Zone.Commands[i].Command = 'G') then LObj := Zone.Commands[i].Command;
     End;
     ShowCommandList;
     lbZone.ItemIndex := num-1;
     lbZone.Selected[num-1] := true;
     lbZone.SetFocus;
end;

procedure TfmCircleEd.SaveZoneFile2Click(Sender: TObject);
var
   i : integer;
   Line : String;
begin
     if (CurZon < 0) or (ZonZone < 0) then exit;
     SaveDialog1.InitialDir  := Options.Strings[0];
     SaveDialog1.FileName    := IntToStr(Zone.VNum)+'.zon';
     SaveDialog1.FilterIndex := 4;
     if SaveDialog1.Execute then
     Begin
          ZoneFile.Clear;
          ZoneFile.Add('#'+IntToStr(Zone.VNum)+' '+Zone.TopCom[1]);
          ZoneFile.Add(Zone.ZoneName+'~ '+Zone.TopCom[2]);
          ZoneFile.Add(IntToStr(Zone.BottomRoom)+' '+IntToStr(Zone.TopRoom)+' '+IntToStr(Zone.LifeSpan)+' '+IntToStr(Zone.ResetMode)+' '+Zone.TopCom[1]);
          for i := 0 to Length(Zone.Commands)-1 do
          Begin
               With Zone.Commands[i] do
               Begin
                    Line := Command + TS(0);
                    Line := Line + IntToStr(IfPar) + TS(IfPar);
                    Line := Line + IntToStr(VNum)   + TS(VNum);
                    Line := Line + IntToStr(Par3)   + TS(Par3);
                    If (Command <> 'R') and (Command <> 'G') then
                       Line := Line + IntToStr(Par4)+ TS(Par4);
                    If Command <> '*' then
                       Line := Line + Comment
                    Else
                       Line := '* '+Comment;
                    ZoneFile.Add(Line);
               End;
          End;
          ZoneFile.Add('S');
          ZoneFile.Add('$');
          ZoneFile.SaveToFile(SaveDialog1.FileName);
     End;
end;

procedure TfmCircleEd.btObjEDAddClick(Sender: TObject);
var
   ObjExtDesc : TObjExtDesc;
   num        : integer;
begin
     if CurObj = -1 then exit;
     ObjExtDesc.Desc := TStringList.Create;
     ObjExtDesc.Keyword   := 'something';
     ObjExtDesc.Desc.Text := 'You see something';
     fmObjExtraDesc.ExtDesc := ObjExtraDescEquals(ObjExtDesc);
     if fmObjExtraDesc.ShowModal = mrOK then
     Begin
          ObjExtDesc := ObjExtraDescEquals(fmObjExtraDesc.ExtDesc);
          num := Length(ObjExt);
          SetLength(ObjExt,num+1);
          ObjExt[num] := ObjExtraDescEquals(fmObjExtraDesc.ExtDesc);
          ObjShowExt;
     End;
end;

procedure TfmCircleEd.btObjEDDeleteClick(Sender: TObject);
Var
   ln,
   i : Integer;
begin
     if CurObj = -1 then exit;
     if lbObjExtraDesc.ItemIndex < 0 then exit;
     ln := Length(ObjExt);
     for i := lbObjExtraDesc.itemindex to ln-2 do
     Begin
          ObjExt[i] := ObjExtraDescEquals(ObjExt[i+1]);
     End;
     SetLength(ObjExt,ln-1);
     ObjShowExt;
end;

procedure TfmCircleEd.btObjEDChangeClick(Sender: TObject);
Var
   ObjExtDesc : TObjExtDesc;
begin
     if CurObj = -1 then exit;
     if lbObjExtraDesc.ItemIndex < 0 then exit;
     ObjExtDesc := ObjExtraDescEquals(ObjExt[lbObjExtraDesc.itemindex]);
     fmObjExtraDesc.ExtDesc := ObjExtraDescEquals(ObjExtDesc);
     if fmObjExtraDesc.ShowModal = mrOK then
     Begin
          ObjExtDesc := fmObjExtraDesc.ExtDesc;
          ObjExt[lbObjExtraDesc.ItemIndex] := ObjExtraDescEquals(ObjExtDesc);
          ObjShowExt;
     End;
end;

procedure TfmCircleEd.btObjAFAddClick(Sender: TObject);
var
   ObjAFTemp : TObjAffFields;
begin
     if CurObj = -1 then exit;
     ObjAFTemp.Location := 1;
     ObjAFTemp.Value    := 1;
     fmObjAF.AF := ObjAFEquals(ObjAFTemp);
     if fmObjAF.ShowModal = mrOK then
     Begin
          ObjAFTemp := ObjAFEquals(fmObjAF.AF);
          Inc(ObjNrAF);
          ObjAF[ObjNrAF] := ObjAFEquals(ObjAFTemp);
          ObjShowAF;
     End;
end;

procedure TfmCircleEd.btObjAFChangeClick(Sender: TObject);
Var
   ObjAFTemp : TObjAffFields;
begin
     if CurObj = -1 then exit;
     if lbObjAffectFields.ItemIndex < 0 then exit;
     ObjAFTemp := ObjAFEquals(ObjAF[lbObjAffectFields.itemindex+1]);
     fmObjAF.AF := ObjAFEquals(ObjAFTemp);
     if fmObjAF.ShowModal = mrOK then
     Begin
          ObjAFTemp := fmObjAF.AF;
          ObjAF[lbObjAffectFields.ItemIndex] := ObjAFEquals(ObjAFTemp);
          ObjShowAF;
     End;
end;

procedure TfmCircleEd.btObjAFDeleteClick(Sender: TObject);
Var
   ln,
   i : Integer;
begin
     if CurObj = -1 then exit;
     if lbObjAffectFields.ItemIndex < 0 then exit;
     ln := ObjNrAF;
     for i := lbObjAffectFields.itemindex to ln-2 do
     Begin
          ObjAF[i] := ObjAFEquals(ObjAF[i+1]);
     End;
     dec(ObjNrAF);
     ObjShowAF;
end;

procedure TfmCircleEd.btMobESAddClick(Sender: TObject);
var
   MobESpec : TESpec;
   num      : integer;
begin
     if CurMob = -1 then exit;
     MobESpec.Spec  := 'Str';
     MobESpec.Value := 1;
     fmMobESpecs.ESpec := MobESEquals(MobESpec);
     if fmMobESpecs.ShowModal = mrOK then
     Begin
          MobESpec := MobESEquals(fmMobESpecs.ESpec);
          num := Length(MobES);
          SetLength(MobES,num+1);
          MobES[num] := MobESEquals(MobESpec);
          MobShowES;
     End;
end;

procedure TfmCircleEd.btMobESDeleteClick(Sender: TObject);
Var
   ln,
   i : Integer;
begin
     if CurMob = -1 then exit;
     if lbMobESpecs.ItemIndex < 0 then exit;
     ln := Length(MobES);
     for i := lbMobESpecs.itemindex to ln-2 do
     Begin
          MobES[i] := MobESEquals(MobES[i+1]);
     End;
     SetLength(MobES,ln-1);
     MobShowES;
end;

procedure TfmCircleEd.btMobESChangeClick(Sender: TObject);
Var
   MobESpec : TESpec;
begin
     if CurMob = -1 then exit;
     if lbMobESpecs.ItemIndex < 0 then exit;
     MobESpec := MobESEquals(MobES[lbMobESpecs.itemindex]);
     fmMobESpecs.ESpec := MobESEquals(MobESpec);
     if fmMobESpecs.ShowModal = mrOK then
     Begin
          MobESpec := MobESEquals(fmMobESpecs.ESpec);
          MobES[lbMobESpecs.ItemIndex] := MobESEquals(MobESpec);
          MobShowES;
     End;
end;

{show my name}
procedure TfmCircleEd.About1Click(Sender: TObject);
begin
     ShowMessage('By Jaco Bezuidenhout');
end;

end.



