unit ObjValHelpUnit;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QButtons;

type
  TfmObjValHelp = class(TForm)
    meHelp: TMemo;
    btClose: TBitBtn;
    btUpdate: TBitBtn;

    Procedure ShowHelp;

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btUpdateClick(Sender: TObject);
  private
    { Private declarations }
  public
    WType  : Integer;
  end;

var
  fmObjValHelp   : TfmObjValHelp;
  ValueHelpFile  : TStringList;

implementation

{$R *.xfm}

Procedure TfmObjValHelp.ShowHelp;
Var
   i  : Integer;

Begin
     if WType < 1 then exit;
     meHelp.Clear;
     i := -1;
     Repeat
           inc(i);
     until ValueHelpFile.Strings[i] = IntToStr(WType);
     Repeat
           inc(i);
           meHelp.Lines.Add(ValueHelpFile.Strings[i]);
     Until (ValueHelpFile.Strings[i+1] = '$') or (ValueHelpFile.Strings[i+1] = '$$') or (i+1 >= ValueHelpFile.Count-1);    

End;

procedure TfmObjValHelp.FormCreate(Sender: TObject);
begin
     ValueHelpFile := TStringList.Create;
     if FileExists('ObjValHelp.dat') then
     Begin
          ValueHelpFile.LoadFromFile('ObjValHelp.dat');
     End;
end;

procedure TfmObjValHelp.FormShow(Sender: TObject);
begin
     ShowHelp;
end;

procedure TfmObjValHelp.btUpdateClick(Sender: TObject);
begin
     ShowHelp;
end;

end.
