unit fmWldDirFieldUnit;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QCheckLst, QComCtrls, QButtons,CircleEdUnit,Jab;

type
  TfmWldDirField = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    meDescription: TMemo;
    cmbDirField: TComboBox;
    Label3: TLabel;
    edKeyWords: TEdit;
    chlbDoorFlag: TCheckListBox;
    Label4: TLabel;
    Label5: TLabel;
    seKeyNumber: TSpinEdit;
    seRoomLinked: TSpinEdit;
    Label6: TLabel;
    btOk: TBitBtn;
    btCancel: TBitBtn;
    procedure btOkClick(Sender: TObject);
    procedure chlbDoorFlagClickCheck(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    DirField : TDirField;
  end;

var
  fmWldDirField: TfmWldDirField;

implementation


{$R *.xfm}

procedure TfmWldDirField.btOkClick(Sender: TObject);
Var
   p1 : String;
begin
     Getparams(cmbDirField.Text,[@p1]);
     DirField.DirNum     := StrToInt(p1);
     DirField.GenDesc.Clear;
     DirField.GenDesc.AddStrings(meDescription.Lines);
     DirField.Keywords   := edKeyWords.Text;
     DirField.DoorFlag   := fmCircleEd.GetFlagNumber(chlbDoorFlag);
     DirField.KeyNum     := seKeyNumber.Value;
     DirField.RoomLinked := seRoomLinked.Value;
end;

procedure TfmWldDirField.chlbDoorFlagClickCheck(Sender: TObject);
Var
   i,
   II : Integer;
begin
     //Change the checkbox listbox into a radio listbox
     II := chlbDoorFlag.ItemIndex;
     for i := 0 to chlbDoorFlag.Items.Count-1 do
         chlbDoorFlag.Checked[i] := false;
     chlbDoorFlag.Checked[II] := true;
     chlbDoorFlag.ItemIndex := II;

     
end;

procedure TfmWldDirField.FormShow(Sender: TObject);
Var
   i : integer;
begin
     chlbDoorFlag.Items.Clear;
     chlbDoorFlag.Items.AddStrings(fmCircleEd.LoadFlags('World_DoorFlag'));
     cmbDirField.ItemIndex := 0;
     cmbDirField.Items.Clear;
     cmbDirField.Items.AddStrings(fmCircleEd.LoadFlags('World_ExitDirection'));
     for i := 0 to cmbDirField.Items.Count-1 do
     Begin
          if Startwith(IntToStr(DirField.DirNum),cmbDirField.Items[i]) then
          Begin
               cmbDirField.ItemIndex := i;
               break;
          End;
     End;
     meDescription.Lines.Clear;
     meDescription.Lines.AddStrings(DirField.GenDesc);
     edKeyWords.Text   := DirField.Keywords;
     for i := 0 to chlbDoorFlag.Items.Count-1 do
     Begin
          if Startwith(IntToStr(DirField.DoorFlag),chlbDoorFlag.Items[i]) then
             chlbDoorFlag.Checked[i] := true
          Else
             chlbDoorFlag.Checked[i] := false;
     End;

     seKeyNumber.Value     := DirField.KeyNum;
     seRoomLinked.Value    := DirField.RoomLinked;
end;

procedure TfmWldDirField.FormCreate(Sender: TObject);
begin
     DirField.GenDesc := TStringList.Create;
end;

end.
